;CodeVisionAVR C Compiler V1.24.6 Professional
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 7,372800 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : No
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "gsm_alarm.vec"
	.INCLUDE "gsm_alarm.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.2c Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : GSM ALARM
;      10 Version : 0.99
;      11 Date    : 22.12.2005
;      12 Author  : black_kite@bk.ru                       
;      13 Company :                                 
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : ATmega8
;      18 Program type        : Application
;      19 Clock frequency     : 7,372800 MHz
;      20 Memory model        : Small
;      21 External SRAM size  : 0
;      22 Data Stack size     : 256
;      23 *****************************************************/
;      24 
;      25 #include <mega8.h>
;      26 #include <stdlib.h>
;      27 //
;      28 #define in1 PINC.0
;      29 #define in2 PINC.1
;      30 #define in3 PINC.2
;      31 #define in4 PINC.3
;      32 #define in5 PINC.4
;      33 #define in6 PINC.5
;      34 #define powsens PINB.1
;      35 #define key PIND.5
;      36 //
;      37 #define out1 PORTD.6
;      38 #define out2 PORTD.7
;      39 #define out3 PORTB.0
;      40 #define out4 PORTB.4
;      41 #define zub  PORTD.2
;      42 #define zubdr DDRD.2
;      43 #define bat  PORTD.3
;      44 #define batdr DDRD.3
;      45 #define sled PORTD.4
;      46 #define iled PORTB.3
;      47 
;      48 // 1 Wire Bus functions
;      49 #asm
;      50    .equ __w1_port=0x18 ;PORTB
   .equ __w1_port=0x18 ;PORTB
;      51    .equ __w1_bit=2
   .equ __w1_bit=2
;      52 #endasm
;      53 #include <1wire.h>
;      54 
;      55 #define RXB8 1
;      56 #define TXB8 0
;      57 #define UPE 2
;      58 #define OVR 3
;      59 #define FE 4
;      60 #define UDRE 5
;      61 #define RXC 7
;      62 
;      63 #define FRAMING_ERROR (1<<FE)
;      64 #define PARITY_ERROR (1<<UPE)
;      65 #define DATA_OVERRUN (1<<OVR)
;      66 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      67 #define RX_COMPLETE (1<<RXC)
;      68 
;      69 // USART Receiver buffer
;      70 #define RX_BUFFER_SIZE 64
;      71 char rx_buffer[RX_BUFFER_SIZE];
_rx_buffer:
	.BYTE 0x40
;      72 
;      73 #if RX_BUFFER_SIZE<256
;      74 unsigned char rx_wr_index,rx_rd_index,rx_counter;
;      75 #else
;      76 unsigned int rx_wr_index,rx_rd_index,rx_counter;
;      77 #endif
;      78 
;      79 // This flag is set on USART Receiver buffer overflow
;      80 bit rx_buffer_overflow;
;      81 
;      82 // USART Receiver interrupt service routine
;      83 interrupt [USART_RXC] void usart_rx_isr(void)
;      84 {

	.CSEG
_usart_rx_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
;      85 char status,data;
;      86 status=UCSRA;
	RCALL __SAVELOCR2
;	status -> R16
;	data -> R17
	IN   R16,11
;      87 data=UDR;
	IN   R17,12
;      88 if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
	MOV  R30,R16
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;      89    {
;      90    rx_buffer[rx_wr_index]=data;
	MOV  R26,R3
	LDI  R27,0
	SUBI R26,LOW(-_rx_buffer)
	SBCI R27,HIGH(-_rx_buffer)
	ST   X,R17
;      91    if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
	INC  R3
	LDI  R30,LOW(64)
	CP   R30,R3
	BRNE _0x4
	CLR  R3
;      92    if (++rx_counter == RX_BUFFER_SIZE)
_0x4:
	INC  R5
	LDI  R30,LOW(64)
	CP   R30,R5
	BRNE _0x5
;      93       {
;      94       rx_counter=0;
	CLR  R5
;      95       rx_buffer_overflow=1;
	SET
	BLD  R2,0
;      96       };
_0x5:
;      97    };
_0x3:
;      98 }
	RCALL __LOADLOCR2P
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;      99 
;     100 #ifndef _DEBUG_TERMINAL_IO_
;     101 // Get a character from the USART Receiver buffer
;     102 #define _ALTERNATE_GETCHAR_
;     103 #pragma used+
;     104 char getchar(void)
;     105 {
_getchar:
;     106 char data;
;     107 while (rx_counter==0);
	ST   -Y,R16
;	data -> R16
_0x6:
	TST  R5
	BREQ _0x6
;     108 data=rx_buffer[rx_rd_index];
	MOV  R30,R4
	LDI  R31,0
	SUBI R30,LOW(-_rx_buffer)
	SBCI R31,HIGH(-_rx_buffer)
	LD   R16,Z
;     109 if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
	INC  R4
	LDI  R30,LOW(64)
	CP   R30,R4
	BRNE _0x9
	CLR  R4
;     110 #asm("cli")
_0x9:
	cli
;     111 --rx_counter;
	DEC  R5
;     112 #asm("sei")
	sei
;     113 return data;
	RCALL SUBOPT_0x0
	RET
;     114 }
;     115 #pragma used-
;     116 #endif
;     117 
;     118 // USART Transmitter buffer
;     119 #define TX_BUFFER_SIZE 64
;     120 char tx_buffer[TX_BUFFER_SIZE];

	.DSEG
_tx_buffer:
	.BYTE 0x40
;     121 
;     122 #if TX_BUFFER_SIZE<256
;     123 unsigned char tx_wr_index,tx_rd_index,tx_counter;
;     124 #else
;     125 unsigned int tx_wr_index,tx_rd_index,tx_counter;
;     126 #endif
;     127 
;     128 // USART Transmitter interrupt service routine
;     129 interrupt [USART_TXC] void usart_tx_isr(void)
;     130 {

	.CSEG
_usart_tx_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     131 if (tx_counter)
	TST  R8
	BREQ _0xA
;     132    {
;     133    --tx_counter;
	DEC  R8
;     134    UDR=tx_buffer[tx_rd_index];
	MOV  R30,R7
	RCALL SUBOPT_0x1
	LD   R30,Z
	OUT  0xC,R30
;     135    if (++tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
	INC  R7
	LDI  R30,LOW(64)
	CP   R30,R7
	BRNE _0xB
	CLR  R7
;     136    };
_0xB:
_0xA:
;     137 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     138 
;     139 #ifndef _DEBUG_TERMINAL_IO_
;     140 // Write a character to the USART Transmitter buffer
;     141 #define _ALTERNATE_PUTCHAR_
;     142 #pragma used+
;     143 void putchar(char c)
;     144 {
_putchar:
;     145 while (tx_counter == TX_BUFFER_SIZE);
_0xC:
	LDI  R30,LOW(64)
	CP   R30,R8
	BREQ _0xC
;     146 #asm("cli")
	cli
;     147 if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
	TST  R8
	BRNE _0x10
	SBIC 0xB,5
	RJMP _0xF
_0x10:
;     148    {
;     149    tx_buffer[tx_wr_index]=c;
	MOV  R30,R6
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x2
;     150    if (++tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
	INC  R6
	LDI  R30,LOW(64)
	CP   R30,R6
	BRNE _0x12
	CLR  R6
;     151    ++tx_counter;
_0x12:
	INC  R8
;     152    }
;     153 else
	RJMP _0x13
_0xF:
;     154    UDR=c;
	LD   R30,Y
	OUT  0xC,R30
;     155 #asm("sei")
_0x13:
	sei
;     156 }
	RJMP _0x243
;     157 #pragma used-
;     158 #endif
;     159 
;     160 // Standard Input/Output functions
;     161 #include <stdio.h>
;     162 
;     163 unsigned int Tdelay[12];//   10 

	.DSEG
_Tdelay:
	.BYTE 0x18
;     164 unsigned int pcount[12];//   10 
_pcount:
	.BYTE 0x18
;     165 unsigned char istatus[12];//  
_istatus:
	.BYTE 0xC
;     166 			  //0- ()
;     167 			  //1-  
;     168 			  //2- 
;     169 			  //(   )
;     170 unsigned int sec;// 0.1
;     171 unsigned char sledpw;//pwm  
;     172 unsigned char iledpw;//pwm   
;     173 unsigned char pwcnt;// pwm'
;     174 unsigned char iphone;//   .
;     175 unsigned char icall;//1-     
_icall:
	.BYTE 0x1
;     176 unsigned char batcount;//   
_batcount:
	.BYTE 0x1
;     177 unsigned char ipwcnt=0;//    
_ipwcnt:
	.BYTE 0x1
;     178 //   sms
;     179 #define SMS_BUFFER_SIZE 64
;     180 unsigned char sms_buffer[SMS_BUFFER_SIZE];
_sms_buffer:
	.BYTE 0x40
;     181 
;     182 unsigned char sms_wr_index,sms_rd_index,sms_counter;
_sms_wr_index:
	.BYTE 0x1
_sms_rd_index:
	.BYTE 0x1
_sms_counter:
	.BYTE 0x1
;     183 unsigned char sms_proc=0;
_sms_proc:
	.BYTE 0x1
;     184 void PutSMS(unsigned char smsn)
;     185 {

	.CSEG
_PutSMS:
;     186  sms_buffer[sms_wr_index]=smsn;
	LDS  R30,_sms_wr_index
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x2
;     187  if (++sms_wr_index == SMS_BUFFER_SIZE) sms_wr_index=0;
	LDS  R26,_sms_wr_index
	SUBI R26,-LOW(1)
	STS  _sms_wr_index,R26
	CPI  R26,LOW(0x40)
	BRNE _0x14
	RCALL SUBOPT_0x4
;     188  if (++sms_counter == SMS_BUFFER_SIZE) sms_counter=0;
_0x14:
	LDS  R26,_sms_counter
	SUBI R26,-LOW(1)
	STS  _sms_counter,R26
	CPI  R26,LOW(0x40)
	BRNE _0x15
	RCALL SUBOPT_0x5
;     189 }
_0x15:
_0x243:
	ADIW R28,1
	RET
;     190 
;     191 unsigned char GetSMS(void)
;     192 {
_GetSMS:
;     193 char smsn;
;     194 smsn=sms_buffer[sms_rd_index];
	ST   -Y,R16
;	smsn -> R16
	LDS  R30,_sms_rd_index
	RCALL SUBOPT_0x3
	LD   R16,Z
;     195 if (++sms_rd_index == SMS_BUFFER_SIZE) sms_rd_index=0;
	LDS  R26,_sms_rd_index
	SUBI R26,-LOW(1)
	STS  _sms_rd_index,R26
	CPI  R26,LOW(0x40)
	BRNE _0x16
	RCALL SUBOPT_0x6
;     196 if (sms_counter)sms_counter--;
_0x16:
	LDS  R30,_sms_counter
	CPI  R30,0
	BREQ _0x17
	SUBI R30,LOW(1)
	STS  _sms_counter,R30
;     197 return smsn;
_0x17:
	RCALL SUBOPT_0x0
	RET
;     198 }
;     199 
;     200 // Timer 1 overflow interrupt service routine
;     201 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     202 {
_timer1_ovf_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     203 char i;
;     204 // Reinitialize Timer 1 value
;     205 TCNT1H=0xFD;
	ST   -Y,R16
;	i -> R16
	RCALL SUBOPT_0x7
;     206 TCNT1L=0x30;
;     207 // Place your code here
;     208 if(sec)sec--;
	MOV  R0,R9
	OR   R0,R10
	BREQ _0x18
	__GETW1R 9,10
	SBIW R30,1
	__PUTW1R 9,10
;     209 for(i=0;i<12;i++)if(Tdelay[i])Tdelay[i]--;
_0x18:
	LDI  R16,LOW(0)
_0x1A:
	CPI  R16,12
	BRGE _0x1B
	RCALL SUBOPT_0x8
	SBIW R30,0
	BREQ _0x1C
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
;     210 if((pwcnt++)>9){pwcnt=0;iphone=(iphone+1)&3;if(sms_proc)sms_proc--;}
_0x1C:
	SUBI R16,-1
	RJMP _0x1A
_0x1B:
	MOV  R30,R13
	INC  R13
	MOV  R26,R30
	LDI  R30,LOW(9)
	CP   R30,R26
	BRSH _0x1D
	CLR  R13
	MOV  R30,R14
	SUBI R30,-LOW(1)
	ANDI R30,LOW(0x3)
	MOV  R14,R30
	LDS  R30,_sms_proc
	CPI  R30,0
	BREQ _0x1E
	SUBI R30,LOW(1)
	STS  _sms_proc,R30
_0x1E:
;     211 sled=(sledpw>pwcnt);
_0x1D:
	MOV  R30,R13
	MOV  R26,R11
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xB
;     212 iled=(iledpw>pwcnt);
	MOV  R30,R13
	MOV  R26,R12
	RCALL SUBOPT_0xA
	IN   R26,0x18
	BLD  R26,3
	OUT  0x18,R26
;     213 if(ipwcnt){iled=1;ipwcnt--;}
	LDS  R30,_ipwcnt
	CPI  R30,0
	BREQ _0x1F
	SBI  0x18,3
	SUBI R30,LOW(1)
	STS  _ipwcnt,R30
;     214 batcount++;
_0x1F:
	LDS  R30,_batcount
	SUBI R30,-LOW(1)
	STS  _batcount,R30
;     215 if(batcount<25){batdr=1;zubdr=1;bat=1;zub=0;}else{batdr=0;zubdr=0;bat=0;zub=0;}
	LDS  R26,_batcount
	CPI  R26,LOW(0x19)
	BRSH _0x20
	SBI  0x11,3
	SBI  0x11,2
	SBI  0x12,3
	CBI  0x12,2
	RJMP _0x21
_0x20:
	CBI  0x11,3
	CBI  0x11,2
	CBI  0x12,3
	CBI  0x12,2
_0x21:
;     216 }
	LD   R16,Y+
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;     217 
;     218 // Declare your global variables here
;     219 
;     220 void init_prog(void)
;     221 {
_init_prog:
;     222 // Declare your local variables here
;     223 
;     224 // Input/Output Ports initialization
;     225 // Port B initialization
;     226 // Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=In Func1=In Func0=Out 
;     227 // State7=T State6=T State5=T State4=0 State3=0 State2=T State1=T State0=0 
;     228 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     229 DDRB=0x19;
	LDI  R30,LOW(25)
	OUT  0x17,R30
;     230 
;     231 // Port C initialization
;     232 // Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
;     233 // State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
;     234 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;     235 DDRC=0x00;
	OUT  0x14,R30
;     236 
;     237 // Port D initialization
;     238 // Func7=Out Func6=Out Func5=In Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
;     239 // State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=T State0=T 
;     240 PORTD=0x00;
	OUT  0x12,R30
;     241 DDRD=0xDC;
	LDI  R30,LOW(220)
	OUT  0x11,R30
;     242 
;     243 // Timer/Counter 0 initialization
;     244 // Clock source: System Clock
;     245 // Clock value: Timer 0 Stopped
;     246 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     247 TCNT0=0x00;
	OUT  0x32,R30
;     248 
;     249 // Timer/Counter 1 initialization
;     250 // Clock source: System Clock
;     251 // Clock value: 7,200 kHz
;     252 // Mode: Normal top=FFFFh
;     253 // OC1A output: Discon.
;     254 // OC1B output: Discon.
;     255 // Noise Canceler: Off
;     256 // Input Capture on Falling Edge
;     257 TCCR1A=0x00;
	OUT  0x2F,R30
;     258 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     259 TCNT1H=0xFD;
	RCALL SUBOPT_0x7
;     260 TCNT1L=0x30;
;     261 ICR1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x27,R30
;     262 ICR1L=0x00;
	OUT  0x26,R30
;     263 OCR1AH=0x00;
	OUT  0x2B,R30
;     264 OCR1AL=0x00;
	OUT  0x2A,R30
;     265 OCR1BH=0x00;
	OUT  0x29,R30
;     266 OCR1BL=0x00;
	OUT  0x28,R30
;     267 
;     268 // Timer/Counter 2 initialization
;     269 // Clock source: System Clock
;     270 // Clock value: Timer 2 Stopped
;     271 // Mode: Normal top=FFh
;     272 // OC2 output: Disconnected
;     273 ASSR=0x00;
	OUT  0x22,R30
;     274 TCCR2=0x00;
	OUT  0x25,R30
;     275 TCNT2=0x00;
	OUT  0x24,R30
;     276 OCR2=0x00;
	OUT  0x23,R30
;     277 
;     278 // External Interrupt(s) initialization
;     279 // INT0: Off
;     280 // INT1: Off
;     281 MCUCR=0x00;
	OUT  0x35,R30
;     282 
;     283 // Timer(s)/Counter(s) Interrupt(s) initialization
;     284 TIMSK=0x04;
	LDI  R30,LOW(4)
	OUT  0x39,R30
;     285 
;     286 // USART initialization
;     287 // Communication Parameters: 8 Data, 1 Stop, No Parity
;     288 // USART Receiver: On
;     289 // USART Transmitter: On
;     290 // USART Mode: Asynchronous
;     291 // USART Baud rate: 19200
;     292 UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
;     293 UCSRB=0xD8;
	LDI  R30,LOW(216)
	OUT  0xA,R30
;     294 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
;     295 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
;     296 UBRRL=0x17;
	LDI  R30,LOW(23)
	OUT  0x9,R30
;     297 
;     298 // Analog Comparator initialization
;     299 // Analog Comparator: Off
;     300 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     301 // Analog Comparator Output: Off
;     302 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     303 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     304 
;     305 // 1 Wire Bus initialization
;     306 w1_init();
	RCALL _w1_init
;     307 
;     308 // Global enable interrupts
;     309 #asm("sei");
	sei
;     310 sms_wr_index=0;
	RCALL SUBOPT_0x4
;     311 sms_rd_index=0;
	RCALL SUBOPT_0x6
;     312 sms_counter=0;
	RCALL SUBOPT_0x5
;     313 }           
	RET
;     314 
;     315 
;     316 #include <delay.h>
;     317 // 
;     318 eeprom char cdata[16*20];//   20  -

	.ESEG
_cdata:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     319 eeprom char ibase[8*24];//  iButton
_ibase:
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
	.DB  0x0
;     320 char idata[9];// 

	.DSEG
_idata:
	.BYTE 0x9
;     321 char powstate;//     
_powstate:
	.BYTE 0x1
;     322 void InitDev(void)// 
;     323 {

	.CSEG
_InitDev:
;     324 unsigned int i;
;     325 for(i=0;i<12;i++)
	RCALL __SAVELOCR2
;	i -> R16,R17
	__GETWRN 16,17,0
_0x23:
	__CPWRN 16,17,12
	BRSH _0x24
;     326  {
;     327  pcount[i]=i*16;
	RCALL SUBOPT_0xC
;     328  Tdelay[i]=0;
;     329  istatus[i]=0;
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
;     330  }
	__ADDWRN 16,17,1
	RJMP _0x23
_0x24:
;     331 }
	RJMP _0x240
;     332 
;     333 //  
;     334 char cmp8byte(char * fd,eeprom char * rd)
;     335 {
_cmp8byte:
;     336 if (rd[0]!=fd[0])return 0;
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x25
	LDI  R30,LOW(0)
	RJMP _0x242
;     337 if (rd[1]!=fd[1])return 0;
_0x25:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,1
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,1
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x26
	LDI  R30,LOW(0)
	RJMP _0x242
;     338 if (rd[2]!=fd[2])return 0;
_0x26:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,2
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x27
	LDI  R30,LOW(0)
	RJMP _0x242
;     339 if (rd[3]!=fd[3])return 0;
_0x27:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,3
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,3
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x28
	LDI  R30,LOW(0)
	RJMP _0x242
;     340 if (rd[4]!=fd[4])return 0;
_0x28:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,4
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0xF
	POP  R26
	CP   R30,R26
	BREQ _0x29
	LDI  R30,LOW(0)
	RJMP _0x242
;     341 if (rd[5]!=fd[5])return 0;
_0x29:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,5
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,5
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x2A
	LDI  R30,LOW(0)
	RJMP _0x242
;     342 if (rd[6]!=fd[6])return 0;
_0x2A:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,6
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,6
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x2B
	LDI  R30,LOW(0)
	RJMP _0x242
;     343 if (rd[7]!=fd[7])return 0;
_0x2B:
	LD   R26,Y
	LDD  R27,Y+1
	ADIW R26,7
	RCALL __EEPROMRDB
	PUSH R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,7
	LD   R30,X
	POP  R26
	CP   R30,R26
	BREQ _0x2C
	LDI  R30,LOW(0)
	RJMP _0x242
;     344 return 1;
_0x2C:
	LDI  R30,LOW(1)
_0x242:
	ADIW R28,4
	RET
;     345 }
;     346 
;     347 char SearchKey()
;     348 {
_SearchKey:
;     349 unsigned char i;
;     350 for(i=0;i<24;i++)
	ST   -Y,R16
;	i -> R16
	LDI  R16,LOW(0)
_0x2E:
	CPI  R16,24
	BRSH _0x2F
;     351 if(cmp8byte(idata,&ibase[i*8]))return 1;
	RCALL SUBOPT_0x10
	MOV  R30,R16
	RCALL __LSLB3
	RCALL SUBOPT_0x11
	ST   -Y,R31
	ST   -Y,R30
	RCALL _cmp8byte
	CPI  R30,0
	BREQ _0x30
	LDI  R30,LOW(1)
	RJMP _0x241
;     352 return 0;
_0x30:
	SUBI R16,-1
	RJMP _0x2E
_0x2F:
	LDI  R30,LOW(0)
_0x241:
	LD   R16,Y+
	RET
;     353 }
;     354 
;     355 void ProgKey(void)
;     356 {
_ProgKey:
;     357 unsigned char i,iptr;
;     358 iptr=0;
	RCALL __SAVELOCR2
;	i -> R16
;	iptr -> R17
	LDI  R17,LOW(0)
;     359 iledpw=1;
	RCALL SUBOPT_0x12
;     360 sledpw=1;
	RCALL SUBOPT_0x13
;     361 for(i=0;i<8*24;i++)ibase[i]=0xAA;// 
	LDI  R16,LOW(0)
_0x32:
	CPI  R16,192
	BRSH _0x33
	RCALL SUBOPT_0x14
	SUBI R26,LOW(-_ibase)
	SBCI R27,HIGH(-_ibase)
	LDI  R30,LOW(170)
	RCALL __EEPROMWRB
;     362 sec=200;
	SUBI R16,-1
	RJMP _0x32
_0x33:
	RCALL SUBOPT_0x15
;     363 while((sec!=0)&&(iptr<24))
_0x34:
	CLR  R0
	CP   R0,R9
	CPC  R0,R10
	BREQ _0x37
	CPI  R17,24
	BRLO _0x38
_0x37:
	RJMP _0x36
_0x38:
;     364  {
;     365        	if(w1_init())
	RCALL SUBOPT_0x16
	BREQ _0x39
;     366       	{
;     367       	for (i=0;i<8;i++)idata[i]=0;
	LDI  R16,LOW(0)
_0x3B:
	CPI  R16,8
	BRSH _0x3C
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
;     368         w1_search(0xf0,idata);
	SUBI R16,-1
	RJMP _0x3B
_0x3C:
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
;     369         if((w1_dow_crc8(idata,8)==0)&&(SearchKey()==0)&&(idata[0]!=0))
	RCALL SUBOPT_0x1A
	BRNE _0x3E
	RCALL SUBOPT_0x1B
	BRNE _0x3E
	RCALL SUBOPT_0x1C
	BRNE _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
;     370         	 {
;     371                  for (i=0;i<8;i++)ibase[iptr*8+i]=idata[i];
	LDI  R16,LOW(0)
_0x41:
	CPI  R16,8
	BRSH _0x42
	MOV  R30,R17
	RCALL __LSLB3
	ADD  R30,R16
	RCALL SUBOPT_0x11
	MOVW R26,R30
	RCALL SUBOPT_0x1D
	SUBI R30,LOW(-_idata)
	SBCI R31,HIGH(-_idata)
	LD   R30,Z
	RCALL __EEPROMWRB
;     372                  iptr++;
	SUBI R16,-1
	RJMP _0x41
_0x42:
	SUBI R17,-1
;     373         	 sledpw=10;
	LDI  R30,LOW(10)
	MOV  R11,R30
;     374         	 iledpw=10;
	MOV  R12,R30
;     375         	 delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x1E
;     376         	 sledpw=1;
	RCALL SUBOPT_0x13
;     377         	 iledpw=1;
	RCALL SUBOPT_0x12
;     378         	 sec=200;
	RCALL SUBOPT_0x15
;     379         	 }
;     380         }
_0x3D:
;     381  }
_0x39:
	RJMP _0x34
_0x36:
;     382  iledpw=0;
	CLR  R12
;     383  sledpw=1;
	RCALL SUBOPT_0x13
;     384 }
_0x240:
	RCALL __LOADLOCR2P
	RET
;     385 
;     386  
;     387 void OutOn(char num)
;     388 {
_OutOn:
;     389    switch (num) {
	LD   R30,Y
;     390         case 1:out1=1;break;
	CPI  R30,LOW(0x1)
	BRNE _0x46
	SBI  0x12,6
	RJMP _0x45
;     391         case 2:out2=1;break;
_0x46:
	CPI  R30,LOW(0x2)
	BRNE _0x47
	SBI  0x12,7
	RJMP _0x45
;     392         case 3:out3=1;break;
_0x47:
	CPI  R30,LOW(0x3)
	BRNE _0x48
	SBI  0x18,0
	RJMP _0x45
;     393         case 4:out4=1;break;
_0x48:
	CPI  R30,LOW(0x4)
	BRNE _0x4A
	SBI  0x18,4
;     394         default:break;
_0x4A:
;     395     		 }
_0x45:
;     396 }
	RJMP _0x23F
;     397 
;     398 void OutOff(char num)
;     399 {
_OutOff:
;     400    switch (num) {
	LD   R30,Y
;     401         case 0:out1=0;
	CPI  R30,0
	BRNE _0x4E
	CBI  0x12,6
;     402                out2=0;
	CBI  0x12,7
;     403                out3=0;
	CBI  0x18,0
;     404                out4=0;break;
	CBI  0x18,4
	RJMP _0x4D
;     405         case 1:out1=0;break;
_0x4E:
	CPI  R30,LOW(0x1)
	BRNE _0x4F
	CBI  0x12,6
	RJMP _0x4D
;     406         case 2:out2=0;break;
_0x4F:
	CPI  R30,LOW(0x2)
	BRNE _0x50
	CBI  0x12,7
	RJMP _0x4D
;     407         case 3:out3=0;break;
_0x50:
	CPI  R30,LOW(0x3)
	BRNE _0x51
	CBI  0x18,0
	RJMP _0x4D
;     408         case 4:out4=0;break;
_0x51:
	CPI  R30,LOW(0x4)
	BRNE _0x53
	CBI  0x18,4
;     409         default:break;
_0x53:
;     410                  }
_0x4D:
;     411 }
_0x23F:
	ADIW R28,1
	RET
;     412 
;     413 unsigned int GetDigit(eeprom char * digstr)
;     414 {
_GetDigit:
;     415 char i=0;
;     416 char str[]="0123";
;     417 while ((digstr[i]>='0')&&(digstr[i]<='9')&&(i<3))
	SBIW R28,5
	LDI  R24,5
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x54*2)
	LDI  R31,HIGH(_0x54*2)
	RCALL __INITLOCB
	ST   -Y,R16
;	*digstr -> Y+6
;	i -> R16
;	str -> Y+1
	LDI  R16,0
_0x55:
	RCALL SUBOPT_0x1F
	CPI  R30,LOW(0x30)
	BRLT _0x58
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x20
	BRLT _0x58
	CPI  R16,3
	BRLT _0x59
_0x58:
	RJMP _0x57
_0x59:
;     418 	{
;     419 	str[i]=digstr[i];
	RCALL SUBOPT_0x1D
	MOVW R26,R28
	ADIW R26,1
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x1F
	POP  R26
	POP  R27
	ST   X,R30
;     420 	i++;
	SUBI R16,-1
;     421 	}
	RJMP _0x55
_0x57:
;     422 str[i]=0;
	RCALL SUBOPT_0x1D
	MOVW R26,R28
	ADIW R26,1
	RCALL SUBOPT_0x21
;     423 return atoi(str);
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _atoi
	LDD  R16,Y+0
	ADIW R28,8
	RET
;     424 }
;     425 
;     426 void SendCR(void)
;     427 {
_SendCR:
;     428 putchar(13); 
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x22
;     429 putchar(10);
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x22
;     430 }
	RET
;     431 
;     432 void InitPhone(void)
;     433 {
_InitPhone:
;     434 printf("ATZ");
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x23
;     435 SendCR();
;     436 delay_ms(200); 
;     437 printf("ATE0");
	__POINTW1FN _0,4
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x23
;     438 SendCR();
;     439 delay_ms(200); 
;     440 printf("AT+CPBS=SM"); 
	__POINTW1FN _0,9
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x23
;     441 SendCR();
;     442 delay_ms(200);
;     443 if(rx_counter)while(rx_counter)getchar();
	TST  R5
	BREQ _0x5A
_0x5B:
	TST  R5
	BREQ _0x5D
	RCALL _getchar
;     444 }
	RJMP _0x5B
_0x5D:
_0x5A:
	RET
;     445 
;     446 void Read2Flash(void)
;     447 {
_Read2Flash:
;     448 unsigned char i,a;
;     449 unsigned int x,n,cptr;           
;     450 char str[]="123";
;     451 sledpw=8;
	SBIW R28,6
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x5E*2)
	LDI  R31,HIGH(_0x5E*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR6
;	i -> R16
;	a -> R17
;	x -> R18,R19
;	n -> R20,R21
;	cptr -> Y+10
;	str -> Y+6
	LDI  R30,LOW(8)
	MOV  R11,R30
;     452 InitPhone();
	RCALL _InitPhone
;     453 if(rx_counter)while(rx_counter)getchar();
	TST  R5
	BREQ _0x5F
_0x60:
	TST  R5
	BREQ _0x62
	RCALL _getchar
;     454 for(n=0;n<20*16;n++)cdata[n]=0;// eeprom 
	RJMP _0x60
_0x62:
_0x5F:
	__GETWRN 20,21,0
_0x64:
	__CPWRN 20,21,320
	BRSH _0x65
	LDI  R26,LOW(_cdata)
	LDI  R27,HIGH(_cdata)
	ADD  R26,R20
	ADC  R27,R21
	LDI  R30,LOW(0)
	RCALL __EEPROMWRB
;     455 for(n=0;n<17;n++)
	__ADDWRN 20,21,1
	RJMP _0x64
_0x65:
	__GETWRN 20,21,0
_0x67:
	__CPWRN 20,21,17
	BRSH _0x68
;     456 {
;     457 printf("AT+CPBR=");
	__POINTW1FN _0,20
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     458 ltoa(n+1,str);
	__GETW1R 20,21
	ADIW R30,1
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R28
	ADIW R30,10
	RCALL SUBOPT_0x25
;     459 i=0;             
	LDI  R16,LOW(0)
;     460 while(str[i])putchar(str[i++]);
_0x69:
	RCALL SUBOPT_0x1D
	RCALL SUBOPT_0x26
	CPI  R30,0
	BREQ _0x6B
	MOV  R30,R16
	SUBI R16,-1
	LDI  R31,0
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x22
;     461 SendCR();
	RJMP _0x69
_0x6B:
	RCALL SUBOPT_0x27
;     462 delay_ms(500);
;     463 i=0;x=0;
	LDI  R16,LOW(0)
	__GETWRN 18,19,0
;     464 if(rx_counter)
	TST  R5
	BREQ _0x6C
;     465 while(rx_counter)
_0x6D:
	TST  R5
	BREQ _0x6F
;     466   {
;     467   a=getchar();
	RCALL SUBOPT_0x28
;     468   if((i==3)&&(a!='"')&&(x<16)){cptr=x+n*16;cdata[cptr]=a;x++;}
	CPI  R16,3
	BRNE _0x71
	CPI  R17,34
	BREQ _0x71
	__CPWRN 18,19,16
	BRLO _0x72
_0x71:
	RJMP _0x70
_0x72:
	__GETW1R 20,21
	RCALL __LSLW4
	ADD  R30,R18
	ADC  R31,R19
	RCALL SUBOPT_0x29
	__ADDWRN 18,19,1
;     469   if(a=='"')i++;
_0x70:
	CPI  R17,34
	BRNE _0x73
	SUBI R16,-1
;     470   }
_0x73:
	RJMP _0x6D
_0x6F:
;     471 }
_0x6C:
	__ADDWRN 20,21,1
	RJMP _0x67
_0x68:
;     472 printf("AT+CPBR=10");//    10 
	__POINTW1FN _0,29
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     473 SendCR();
	RCALL SUBOPT_0x27
;     474 delay_ms(500);
;     475 i=0;x=0;
	LDI  R16,LOW(0)
	__GETWRN 18,19,0
;     476 if(rx_counter)
	TST  R5
	BREQ _0x74
;     477 while(rx_counter)
_0x75:
	TST  R5
	BREQ _0x77
;     478   {
;     479   a=getchar();
	RCALL SUBOPT_0x28
;     480   if((i==1)&&(a!='"')&&(x<16)){cptr=x+17*16;cdata[cptr]=a;x++;}
	CPI  R16,1
	BRNE _0x79
	CPI  R17,34
	BREQ _0x79
	__CPWRN 18,19,16
	BRLO _0x7A
_0x79:
	RJMP _0x78
_0x7A:
	__GETW1R 18,19
	SUBI R30,LOW(-272)
	SBCI R31,HIGH(-272)
	RCALL SUBOPT_0x29
	__ADDWRN 18,19,1
;     481   if(a=='"')i++;
_0x78:
	CPI  R17,34
	BRNE _0x7B
	SUBI R16,-1
;     482   }
_0x7B:
	RJMP _0x75
_0x77:
;     483 printf("AT+CPBR=11");//    11 
_0x74:
	__POINTW1FN _0,40
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     484 SendCR();
	RCALL SUBOPT_0x27
;     485 delay_ms(500);
;     486 i=0;x=0;
	LDI  R16,LOW(0)
	__GETWRN 18,19,0
;     487 if(rx_counter)
	TST  R5
	BREQ _0x7C
;     488 while(rx_counter)
_0x7D:
	TST  R5
	BREQ _0x7F
;     489   {
;     490   a=getchar();
	RCALL SUBOPT_0x28
;     491   if((i==1)&&(a!='"')&&(x<16)){cptr=x+18*16;cdata[cptr]=a;x++;}
	CPI  R16,1
	BRNE _0x81
	CPI  R17,34
	BREQ _0x81
	__CPWRN 18,19,16
	BRLO _0x82
_0x81:
	RJMP _0x80
_0x82:
	__GETW1R 18,19
	SUBI R30,LOW(-288)
	SBCI R31,HIGH(-288)
	RCALL SUBOPT_0x29
	__ADDWRN 18,19,1
;     492   if(a=='"')i++;
_0x80:
	CPI  R17,34
	BRNE _0x83
	SUBI R16,-1
;     493   }
_0x83:
	RJMP _0x7D
_0x7F:
;     494 printf("AT+CPBR=12");//    12 
_0x7C:
	__POINTW1FN _0,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     495 SendCR();
	RCALL SUBOPT_0x27
;     496 delay_ms(500);
;     497 i=0;x=0;
	LDI  R16,LOW(0)
	__GETWRN 18,19,0
;     498 if(rx_counter)
	TST  R5
	BREQ _0x84
;     499 while(rx_counter)
_0x85:
	TST  R5
	BREQ _0x87
;     500   {
;     501   a=getchar();
	RCALL SUBOPT_0x28
;     502   if((i==1)&&(a!='"')&&(x<16)){cptr=x+19*16;cdata[cptr]=a;x++;}
	CPI  R16,1
	BRNE _0x89
	CPI  R17,34
	BREQ _0x89
	__CPWRN 18,19,16
	BRLO _0x8A
_0x89:
	RJMP _0x88
_0x8A:
	__GETW1R 18,19
	SUBI R30,LOW(-304)
	SBCI R31,HIGH(-304)
	RCALL SUBOPT_0x29
	__ADDWRN 18,19,1
;     503   if(a=='"')i++;
_0x88:
	CPI  R17,34
	BRNE _0x8B
	SUBI R16,-1
;     504   }
_0x8B:
	RJMP _0x85
_0x87:
;     505 sledpw=0;
_0x84:
	CLR  R11
;     506   for(cptr=0;cptr<20*16;cptr++){sled=(cdata[cptr]>0);delay_ms(16);}
	LDI  R30,0
	STD  Y+10,R30
	STD  Y+10+1,R30
_0x8D:
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CPI  R26,LOW(0x140)
	LDI  R30,HIGH(0x140)
	CPC  R27,R30
	BRSH _0x8E
	SUBI R26,LOW(-_cdata)
	SBCI R27,HIGH(-_cdata)
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDI  R30,LOW(0)
	RCALL __GTB12
	BST  R30,0
	RCALL SUBOPT_0xB
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	RCALL SUBOPT_0x1E
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	ADIW R30,1
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x8D
_0x8E:
;     507 sledpw=1;
	RCALL SUBOPT_0x13
;     508 }
	RCALL __LOADLOCR6
	ADIW R28,12
	RET
;     509 
;     510 void SendSMS(unsigned char smsn) // sms  
;     511 {
_SendSMS:
;     512 char str[]="123";
;     513 int i=0;
;     514 printf("AT+CMSS=");
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x8F*2)
	LDI  R31,HIGH(_0x8F*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR2
;	smsn -> Y+6
;	str -> Y+2
;	i -> R16,R17
	LDI  R16,0
	LDI  R17,0
	__POINTW1FN _0,62
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     515 ltoa(smsn,str);
	LDD  R30,Y+6
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x25
;     516 while(str[i])putchar(str[i++]);
_0x90:
	MOVW R26,R28
	ADIW R26,2
	ADD  R26,R16
	ADC  R27,R17
	LD   R30,X
	CPI  R30,0
	BREQ _0x92
	__GETW1R 16,17
	__ADDWRN 16,17,1
	MOVW R26,R28
	ADIW R26,2
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RCALL SUBOPT_0x22
;     517 SendCR();
	RJMP _0x90
_0x92:
	RCALL _SendCR
;     518 }
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
;     519 
;     520 void DeactiveDevice(unsigned char n)//   
;     521 				    //n=0    - 
;     522 {
_DeactiveDevice:
;     523 unsigned char i;
;     524 if(n<7)
	RCALL SUBOPT_0x2A
;	n -> Y+1
;	i -> R16
	BRSH _0x93
;     525 {
;     526 if(n)
	RCALL SUBOPT_0x2B
	BREQ _0x94
;     527  {
;     528   n--;
	RCALL SUBOPT_0x2C
;     529   if((cdata[n*16]=='-')||(cdata[n*16]=='+'))
	RCALL SUBOPT_0x2D
	CPI  R30,LOW(0x2D)
	BREQ _0x96
	LDD  R30,Y+1
	RCALL SUBOPT_0x2D
	CPI  R30,LOW(0x2B)
	BRNE _0x95
_0x96:
;     530   {
;     531    Tdelay[n]=0;
	LDD  R30,Y+1
	RCALL SUBOPT_0x2E
;     532    istatus[n]=2;
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0x30
;     533    pcount[n]=n*16;
	RCALL SUBOPT_0x31
;     534   }
;     535  }
_0x95:
;     536  else
	RJMP _0x98
_0x94:
;     537  for(i=0;i<6;i++)
	LDI  R16,LOW(0)
_0x9A:
	CPI  R16,6
	BRSH _0x9B
;     538  {
;     539  switch (cdata[i*16])
	RCALL SUBOPT_0x32
;     540   {
;     541         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0xA0
;     542         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0xA2
_0xA0:
;     543         Tdelay[i]=0;
	RCALL SUBOPT_0x33
;     544         istatus[i]=2;
	RCALL SUBOPT_0x14
	SUBI R26,LOW(-_istatus)
	SBCI R27,HIGH(-_istatus)
	RCALL SUBOPT_0x30
;     545         pcount[i]=i*16;
	RCALL SUBOPT_0x34
;     546         break;
;     547         
;     548         default:
_0xA2:
;     549         break;
;     550   }
;     551  }
	SUBI R16,-1
	RJMP _0x9A
_0x9B:
_0x98:
;     552 }
;     553 }
_0x93:
	RJMP _0x23E
;     554 
;     555 void ActiveDevice(unsigned char n)//   
;     556 				  //n=0    - 
;     557 {
_ActiveDevice:
;     558 unsigned char i;
;     559 if(n<7)
	RCALL SUBOPT_0x2A
;	n -> Y+1
;	i -> R16
	BRSH _0xA3
;     560 {
;     561 if(n)
	RCALL SUBOPT_0x2B
	BREQ _0xA4
;     562  {
;     563   n--;
	RCALL SUBOPT_0x2C
;     564   Tdelay[n]=0;
	RCALL SUBOPT_0x2E
;     565   istatus[n]=0;
	RCALL SUBOPT_0x2F
	RCALL SUBOPT_0xE
;     566   pcount[n]=n*16;
	RCALL SUBOPT_0x31
;     567  }
;     568  else
	RJMP _0xA5
_0xA4:
;     569  for(i=0;i<6;i++)
	LDI  R16,LOW(0)
_0xA7:
	CPI  R16,6
	BRSH _0xA8
;     570  {
;     571  switch (cdata[i*16])
	RCALL SUBOPT_0x32
;     572   {
;     573         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0xAD
;     574         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0xAF
_0xAD:
;     575         Tdelay[i]=0;
	RCALL SUBOPT_0x33
;     576         istatus[i]=0;
	RCALL SUBOPT_0x14
	SUBI R26,LOW(-_istatus)
	SBCI R27,HIGH(-_istatus)
	RCALL SUBOPT_0xE
;     577         pcount[i]=i*16;
	RCALL SUBOPT_0x34
;     578         break;
;     579         
;     580         default:
_0xAF:
;     581         break;
;     582   }
;     583  }
	SUBI R16,-1
	RJMP _0xA7
_0xA8:
_0xA5:
;     584 }
;     585 }
_0xA3:
_0x23E:
	LDD  R16,Y+0
	ADIW R28,2
	RET
;     586 
;     587 void CommandInterpretator(char curprog)
;     588 {
_CommandInterpretator:
;     589 int adr;
;     590 adr=pcount[curprog];
	RCALL __SAVELOCR2
;	curprog -> Y+2
;	adr -> R16,R17
	RCALL SUBOPT_0x35
	ADD  R26,R30
	ADC  R27,R31
	LD   R16,X+
	LD   R17,X
;     591    switch (cdata[adr]) 
	LDI  R26,LOW(_cdata)
	LDI  R27,HIGH(_cdata)
	ADD  R26,R16
	ADC  R27,R17
	RCALL __EEPROMRDB
;     592    {
;     593 //sms
;     594         case 's':
	CPI  R30,LOW(0x73)
	BREQ _0xB4
;     595         case 'S':
	CPI  R30,LOW(0x53)
	BRNE _0xB5
_0xB4:
;     596         PutSMS(GetDigit(&cdata[adr+1]));
	RCALL SUBOPT_0x36
	ST   -Y,R30
	RCALL _PutSMS
;     597         break;
	RJMP _0xB2
;     598 //delay  
;     599         case 'd':
_0xB5:
	CPI  R30,LOW(0x64)
	BREQ _0xB7
;     600         case 'D':
	CPI  R30,LOW(0x44)
	BRNE _0xB8
_0xB7:
;     601         Tdelay[curprog]=10*GetDigit(&cdata[adr+1]);
	RCALL SUBOPT_0x37
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x36
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL __MULW12U
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     602         break;
	RJMP _0xB2
;     603 //delay  
;     604         case 'm':
_0xB8:
	CPI  R30,LOW(0x6D)
	BREQ _0xBA
;     605         case 'M':
	CPI  R30,LOW(0x4D)
	BRNE _0xBB
_0xBA:
;     606         Tdelay[curprog]=600*GetDigit(&cdata[adr+1]);
	RCALL SUBOPT_0x37
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x36
	LDI  R26,LOW(600)
	LDI  R27,HIGH(600)
	RCALL __MULW12U
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     607         break;
	RJMP _0xB2
;     608 //on
;     609         case 'c':
_0xBB:
	CPI  R30,LOW(0x63)
	BREQ _0xBD
;     610         case 'C':
	CPI  R30,LOW(0x43)
	BRNE _0xBE
_0xBD:
;     611         OutOn(GetDigit(&cdata[adr+1]));
	RCALL SUBOPT_0x36
	ST   -Y,R30
	RCALL _OutOn
;     612         break;
	RJMP _0xB2
;     613 //off
;     614         case 'r':
_0xBE:
	CPI  R30,LOW(0x72)
	BREQ _0xC0
;     615         case 'R':
	CPI  R30,LOW(0x52)
	BRNE _0xC1
_0xC0:
;     616         OutOff(GetDigit(&cdata[adr+1]));
	RCALL SUBOPT_0x36
	ST   -Y,R30
	RCALL _OutOff
;     617         break;
	RJMP _0xB2
;     618 //branch
;     619         case 'n':
_0xC1:
	CPI  R30,LOW(0x6E)
	BREQ _0xC3
;     620         case 'N':
	CPI  R30,LOW(0x4E)
	BRNE _0xC4
_0xC3:
;     621         pcount[curprog]=16*(GetDigit(&cdata[adr+1])-1)-1;
	RCALL SUBOPT_0x35
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x36
	SBIW R30,1
	RCALL __LSLW4
	SBIW R30,1
	POP  R26
	POP  R27
	ST   X+,R30
	ST   X,R31
;     622         break;
	RJMP _0xB2
;     623 //passive
;     624         case 'p':
_0xC4:
	CPI  R30,LOW(0x70)
	BREQ _0xC6
;     625         case 'P':
	CPI  R30,LOW(0x50)
	BRNE _0xC7
_0xC6:
;     626         DeactiveDevice(GetDigit(&cdata[adr+1]));
	RCALL SUBOPT_0x36
	ST   -Y,R30
	RCALL _DeactiveDevice
;     627         break;
	RJMP _0xB2
;     628 //active
;     629         case 'a':
_0xC7:
	CPI  R30,LOW(0x61)
	BREQ _0xC9
;     630         case 'A':
	CPI  R30,LOW(0x41)
	BRNE _0xCA
_0xC9:
;     631         ActiveDevice(GetDigit(&cdata[adr+1]));
	RCALL SUBOPT_0x36
	ST   -Y,R30
	RCALL _ActiveDevice
;     632         break;
	RJMP _0xB2
;     633 //zvonok
;     634         case 'z':
_0xCA:
	CPI  R30,LOW(0x7A)
	BREQ _0xCC
;     635         case 'Z':
	CPI  R30,LOW(0x5A)
	BRNE _0xCD
_0xCC:
;     636         if(icall==0)
	LDS  R30,_icall
	CPI  R30,0
	BRNE _0xCE
;     637         {
;     638         printf("ATH");
	__POINTW1FN _0,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     639         SendCR();
	RCALL _SendCR
;     640         icall=1;
	LDI  R30,LOW(1)
	STS  _icall,R30
;     641         Tdelay[curprog]=8;
	LDD  R30,Y+2
	LDI  R26,LOW(_Tdelay)
	LDI  R27,HIGH(_Tdelay)
	LDI  R31,0
	RCALL SUBOPT_0x38
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   X+,R30
	ST   X,R31
;     642         pcount[curprog]--;
	RCALL SUBOPT_0x35
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	RCALL SUBOPT_0x9
;     643         }
;     644         else
	RJMP _0xCF
_0xCE:
;     645         {              
;     646         printf("ATD>");
	__POINTW1FN _0,75
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     647         putchar(cdata[adr+1]);
	__GETW1R 16,17
	ADIW R30,1
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x22
;     648         if((cdata[adr+2]>='0')&&(cdata[adr+2]<='9'))putchar(cdata[adr+2]);
	RCALL SUBOPT_0x3A
	CPI  R30,LOW(0x30)
	BRLT _0xD1
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x20
	BRGE _0xD2
_0xD1:
	RJMP _0xD0
_0xD2:
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x22
;     649         putchar(';');
_0xD0:
	LDI  R30,LOW(59)
	RCALL SUBOPT_0x22
;     650         SendCR();
	RCALL _SendCR
;     651         }
_0xCF:
;     652         break;
	RJMP _0xB2
;     653 //otboy
;     654         case 'x':
_0xCD:
	CPI  R30,LOW(0x78)
	BREQ _0xD4
;     655         case 'X':
	CPI  R30,LOW(0x58)
	BRNE _0xD6
_0xD4:
;     656         printf("ATH");
	__POINTW1FN _0,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     657         SendCR();
	RCALL _SendCR
;     658         icall=0;
	RCALL SUBOPT_0x3B
;     659         break;
;     660                 
;     661         default:
_0xD6:
;     662         break;
;     663    }
_0xB2:
;     664 }
	RCALL __LOADLOCR2
	ADIW R28,3
	RET
;     665 
;     666 void ScanIN1(void)
;     667 {
_ScanIN1:
;     668 unsigned int n=0;
;     669 if((cdata[n*16]=='*')&&(!in1)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
	RCALL __SAVELOCR2
;	n -> R16,R17
	LDI  R16,0
	LDI  R17,0
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2A)
	BRNE _0xD8
	SBIC 0x13,0
	RJMP _0xD8
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0xD9
_0xD8:
	RJMP _0xD7
_0xD9:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     670 if((cdata[n*16]=='-')&&(!in1)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0xD7:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2D)
	BRNE _0xDB
	SBIC 0x13,0
	RJMP _0xDB
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0xDC
_0xDB:
	RJMP _0xDA
_0xDC:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     671 if((cdata[n*16]=='+')&&(in1)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0xDA:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2B)
	BRNE _0xDE
	SBIS 0x13,0
	RJMP _0xDE
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0xDF
_0xDE:
	RJMP _0xDD
_0xDF:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     672 if((istatus[n]==1)&&(Tdelay[n]==0))
_0xDD:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3F
	BRNE _0xE1
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	BREQ _0xE2
_0xE1:
	RJMP _0xE0
_0xE2:
;     673  {
;     674  pcount[n]++;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x43
;     675  if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
	RCALL SUBOPT_0x44
	CPI  R30,0
	BREQ _0xE3
	RCALL SUBOPT_0x45
	RJMP _0xE4
_0xE3:
;     676   switch (cdata[n*16])
	RCALL SUBOPT_0x3C
;     677   {
;     678         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0xE9
;     679         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0xEA
_0xE9:
;     680         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     681         istatus[n]=2;
	RCALL SUBOPT_0x30
;     682         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     683         break;
	RJMP _0xE7
;     684         case '*':
_0xEA:
	CPI  R30,LOW(0x2A)
	BRNE _0xEC
;     685         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     686         istatus[n]=0;
	RCALL SUBOPT_0xE
;     687         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     688         break;
;     689         default:
_0xEC:
;     690         break;
;     691   } 
_0xE7:
_0xE4:
;     692  }
;     693 }
_0xE0:
	RJMP _0x23D
;     694 
;     695 void ScanIN2(void)
;     696 {
_ScanIN2:
;     697 unsigned int n=1;
;     698 if((cdata[n*16]=='*')&&(!in2)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
	RCALL __SAVELOCR2
;	n -> R16,R17
	LDI  R16,1
	LDI  R17,0
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2A)
	BRNE _0xEE
	SBIC 0x13,1
	RJMP _0xEE
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0xEF
_0xEE:
	RJMP _0xED
_0xEF:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     699 if((cdata[n*16]=='-')&&(!in2)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0xED:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2D)
	BRNE _0xF1
	SBIC 0x13,1
	RJMP _0xF1
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0xF2
_0xF1:
	RJMP _0xF0
_0xF2:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     700 if((cdata[n*16]=='+')&&(in2)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0xF0:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2B)
	BRNE _0xF4
	SBIS 0x13,1
	RJMP _0xF4
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0xF5
_0xF4:
	RJMP _0xF3
_0xF5:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     701 if((istatus[n]==1)&&(Tdelay[n]==0))
_0xF3:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3F
	BRNE _0xF7
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	BREQ _0xF8
_0xF7:
	RJMP _0xF6
_0xF8:
;     702  {
;     703  pcount[n]++;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x43
;     704  if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
	RCALL SUBOPT_0x44
	CPI  R30,0
	BREQ _0xF9
	RCALL SUBOPT_0x45
	RJMP _0xFA
_0xF9:
;     705   switch (cdata[n*16])
	RCALL SUBOPT_0x3C
;     706   {
;     707         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0xFF
;     708         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0x100
_0xFF:
;     709         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     710         istatus[n]=2;
	RCALL SUBOPT_0x30
;     711         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     712         break;
	RJMP _0xFD
;     713         case '*':
_0x100:
	CPI  R30,LOW(0x2A)
	BRNE _0x102
;     714         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     715         istatus[n]=0;
	RCALL SUBOPT_0xE
;     716         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     717         break;        
;     718         default:
_0x102:
;     719         break;
;     720   } 
_0xFD:
_0xFA:
;     721  }
;     722 }
_0xF6:
	RJMP _0x23D
;     723 
;     724 void ScanIN3(void)
;     725 {
_ScanIN3:
;     726 unsigned int n=2;
;     727 if((cdata[n*16]=='*')&&(!in3)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
	RCALL __SAVELOCR2
;	n -> R16,R17
	LDI  R16,2
	LDI  R17,0
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2A)
	BRNE _0x104
	SBIC 0x13,2
	RJMP _0x104
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x105
_0x104:
	RJMP _0x103
_0x105:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     728 if((cdata[n*16]=='-')&&(!in3)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x103:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2D)
	BRNE _0x107
	SBIC 0x13,2
	RJMP _0x107
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x108
_0x107:
	RJMP _0x106
_0x108:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     729 if((cdata[n*16]=='+')&&(in3)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x106:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2B)
	BRNE _0x10A
	SBIS 0x13,2
	RJMP _0x10A
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x10B
_0x10A:
	RJMP _0x109
_0x10B:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     730 if((istatus[n]==1)&&(Tdelay[n]==0))
_0x109:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3F
	BRNE _0x10D
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	BREQ _0x10E
_0x10D:
	RJMP _0x10C
_0x10E:
;     731  {
;     732  pcount[n]++;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x43
;     733  if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
	RCALL SUBOPT_0x44
	CPI  R30,0
	BREQ _0x10F
	RCALL SUBOPT_0x45
	RJMP _0x110
_0x10F:
;     734   switch (cdata[n*16])
	RCALL SUBOPT_0x3C
;     735   {
;     736         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0x115
;     737         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0x116
_0x115:
;     738         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     739         istatus[n]=2;
	RCALL SUBOPT_0x30
;     740         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     741         break;
	RJMP _0x113
;     742         case '*':
_0x116:
	CPI  R30,LOW(0x2A)
	BRNE _0x118
;     743         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     744         istatus[n]=0;
	RCALL SUBOPT_0xE
;     745         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     746         break;        
;     747         default:
_0x118:
;     748         break;
;     749   } 
_0x113:
_0x110:
;     750  }
;     751 }
_0x10C:
	RJMP _0x23D
;     752 
;     753 void ScanIN4(void)
;     754 {
_ScanIN4:
;     755 unsigned int n=3;
;     756 if((cdata[n*16]=='*')&&(!in4)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
	RCALL __SAVELOCR2
;	n -> R16,R17
	LDI  R16,3
	LDI  R17,0
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2A)
	BRNE _0x11A
	SBIC 0x13,3
	RJMP _0x11A
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x11B
_0x11A:
	RJMP _0x119
_0x11B:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     757 if((cdata[n*16]=='-')&&(!in4)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x119:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2D)
	BRNE _0x11D
	SBIC 0x13,3
	RJMP _0x11D
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x11E
_0x11D:
	RJMP _0x11C
_0x11E:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     758 if((cdata[n*16]=='+')&&(in4)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x11C:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2B)
	BRNE _0x120
	SBIS 0x13,3
	RJMP _0x120
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x121
_0x120:
	RJMP _0x11F
_0x121:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     759 if((istatus[n]==1)&&(Tdelay[n]==0))
_0x11F:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3F
	BRNE _0x123
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	BREQ _0x124
_0x123:
	RJMP _0x122
_0x124:
;     760  {
;     761  pcount[n]++;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x43
;     762  if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
	RCALL SUBOPT_0x44
	CPI  R30,0
	BREQ _0x125
	RCALL SUBOPT_0x45
	RJMP _0x126
_0x125:
;     763   switch (cdata[n*16])
	RCALL SUBOPT_0x3C
;     764   {
;     765         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0x12B
;     766         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0x12C
_0x12B:
;     767         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     768         istatus[n]=2;
	RCALL SUBOPT_0x30
;     769         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     770         break;
	RJMP _0x129
;     771         case '*':
_0x12C:
	CPI  R30,LOW(0x2A)
	BRNE _0x12E
;     772         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     773         istatus[n]=0;
	RCALL SUBOPT_0xE
;     774         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     775         break;        
;     776         default:
_0x12E:
;     777         break;
;     778   } 
_0x129:
_0x126:
;     779  }
;     780 }
_0x122:
	RJMP _0x23D
;     781 
;     782 void ScanIN5(void)
;     783 {
_ScanIN5:
;     784 unsigned int n=4;
;     785 if((cdata[n*16]=='*')&&(!in5)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
	RCALL __SAVELOCR2
;	n -> R16,R17
	LDI  R16,4
	LDI  R17,0
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2A)
	BRNE _0x130
	SBIC 0x13,4
	RJMP _0x130
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x131
_0x130:
	RJMP _0x12F
_0x131:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     786 if((cdata[n*16]=='-')&&(!in5)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x12F:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2D)
	BRNE _0x133
	SBIC 0x13,4
	RJMP _0x133
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x134
_0x133:
	RJMP _0x132
_0x134:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     787 if((cdata[n*16]=='+')&&(in5)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x132:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2B)
	BRNE _0x136
	SBIS 0x13,4
	RJMP _0x136
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x137
_0x136:
	RJMP _0x135
_0x137:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     788 if((istatus[n]==1)&&(Tdelay[n]==0))
_0x135:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3F
	BRNE _0x139
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	BREQ _0x13A
_0x139:
	RJMP _0x138
_0x13A:
;     789  {
;     790  pcount[n]++;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x43
;     791  if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
	RCALL SUBOPT_0x44
	CPI  R30,0
	BREQ _0x13B
	RCALL SUBOPT_0x45
	RJMP _0x13C
_0x13B:
;     792   switch (cdata[n*16])
	RCALL SUBOPT_0x3C
;     793   {
;     794         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0x141
;     795         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0x142
_0x141:
;     796         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     797         istatus[n]=2;
	RCALL SUBOPT_0x30
;     798         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     799         break;
	RJMP _0x13F
;     800         case '*':
_0x142:
	CPI  R30,LOW(0x2A)
	BRNE _0x144
;     801         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     802         istatus[n]=0;
	RCALL SUBOPT_0xE
;     803         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     804         break;        
;     805         default:
_0x144:
;     806         break;
;     807   } 
_0x13F:
_0x13C:
;     808  }
;     809 }
_0x138:
	RJMP _0x23D
;     810 
;     811 void ScanIN6(void)
;     812 {
_ScanIN6:
;     813 unsigned int n=5;
;     814 if((cdata[n*16]=='*')&&(!in6)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
	RCALL __SAVELOCR2
;	n -> R16,R17
	LDI  R16,5
	LDI  R17,0
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2A)
	BRNE _0x146
	SBIC 0x13,5
	RJMP _0x146
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x147
_0x146:
	RJMP _0x145
_0x147:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     815 if((cdata[n*16]=='-')&&(!in6)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x145:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2D)
	BRNE _0x149
	SBIC 0x13,5
	RJMP _0x149
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x14A
_0x149:
	RJMP _0x148
_0x14A:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     816 if((cdata[n*16]=='+')&&(in6)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
_0x148:
	RCALL SUBOPT_0x3C
	CPI  R30,LOW(0x2B)
	BRNE _0x14C
	SBIS 0x13,5
	RJMP _0x14C
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3D
	BREQ _0x14D
_0x14C:
	RJMP _0x14B
_0x14D:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3E
;     817 if((istatus[n]==1)&&(Tdelay[n]==0))
_0x14B:
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x3F
	BRNE _0x14F
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x41
	BREQ _0x150
_0x14F:
	RJMP _0x14E
_0x150:
;     818  {
;     819  pcount[n]++;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x43
;     820  if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
	RCALL SUBOPT_0x44
	CPI  R30,0
	BREQ _0x151
	RCALL SUBOPT_0x45
	RJMP _0x152
_0x151:
;     821   switch (cdata[n*16])
	RCALL SUBOPT_0x3C
;     822   {
;     823         case '+':
	CPI  R30,LOW(0x2B)
	BREQ _0x157
;     824         case '-':
	CPI  R30,LOW(0x2D)
	BRNE _0x158
_0x157:
;     825         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     826         istatus[n]=2;
	RCALL SUBOPT_0x30
;     827         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     828         break;
	RJMP _0x155
;     829         case '*':
_0x158:
	CPI  R30,LOW(0x2A)
	BRNE _0x15A
;     830         Tdelay[n]=0;
	RCALL SUBOPT_0x40
	RCALL SUBOPT_0x46
;     831         istatus[n]=0;
	RCALL SUBOPT_0xE
;     832         pcount[n]=n*16;
	RCALL SUBOPT_0x42
	RCALL SUBOPT_0x47
;     833         break;        
;     834         default:
_0x15A:
;     835         break;
;     836   } 
_0x155:
_0x152:
;     837  }
;     838 }
_0x14E:
_0x23D:
	RCALL __LOADLOCR2P
	RET
;     839 
;     840 void ScanIN78(void)
;     841 {
_ScanIN78:
;     842 if((powsens!=powstate))
	LDI  R30,0
	SBIC 0x16,1
	LDI  R30,1
	LDS  R26,_powstate
	CP   R30,R26
	BRNE PC+2
	RJMP _0x15B
;     843 {
;     844 if(!powsens){istatus[6]=1;pcount[6]=6*16;Tdelay[6]=0;istatus[7]=0;pcount[7]=7*16;Tdelay[7]=0;}
	SBIC 0x16,1
	RJMP _0x15C
	LDI  R30,LOW(1)
	__PUTB1MN _istatus,6
	LDI  R30,LOW(96)
	LDI  R31,HIGH(96)
	__PUTW1MN _pcount,12
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,12
	__PUTB1MN _istatus,7
	LDI  R30,LOW(112)
	LDI  R31,HIGH(112)
	__PUTW1MN _pcount,14
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,14
;     845 else {istatus[7]=1;pcount[7]=7*16;Tdelay[7]=0;istatus[6]=0;pcount[6]=6*16;Tdelay[6]=0;}
	RJMP _0x15D
_0x15C:
	LDI  R30,LOW(1)
	__PUTB1MN _istatus,7
	LDI  R30,LOW(112)
	LDI  R31,HIGH(112)
	__PUTW1MN _pcount,14
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,14
	__PUTB1MN _istatus,6
	LDI  R30,LOW(96)
	LDI  R31,HIGH(96)
	__PUTW1MN _pcount,12
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,12
_0x15D:
;     846 }
;     847 
;     848 if((istatus[6]==1)&&(Tdelay[6]==0))
_0x15B:
	__GETB1MN _istatus,6
	CPI  R30,LOW(0x1)
	BRNE _0x15F
	__GETW1MN _Tdelay,12
	SBIW R30,0
	BREQ _0x160
_0x15F:
	RJMP _0x15E
_0x160:
;     849  {
;     850  pcount[6]++;
	__POINTW2MN _pcount,12
	RCALL SUBOPT_0x48
;     851  if(cdata[pcount[6]]!=0)CommandInterpretator(6);else
	__GETW1MN _pcount,12
	RCALL SUBOPT_0x39
	CPI  R30,0
	BREQ _0x161
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x49
	RJMP _0x162
_0x161:
;     852   {
;     853    Tdelay[6]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,12
;     854    istatus[6]=0;
	__PUTB1MN _istatus,6
;     855    pcount[6]=6*16;
	LDI  R30,LOW(96)
	LDI  R31,HIGH(96)
	__PUTW1MN _pcount,12
;     856   } 
_0x162:
;     857  }
;     858 if((istatus[7]==1)&&(Tdelay[7]==0))
_0x15E:
	__GETB1MN _istatus,7
	CPI  R30,LOW(0x1)
	BRNE _0x164
	__GETW1MN _Tdelay,14
	SBIW R30,0
	BREQ _0x165
_0x164:
	RJMP _0x163
_0x165:
;     859  {
;     860  pcount[7]++;
	__POINTW2MN _pcount,14
	RCALL SUBOPT_0x48
;     861  if(cdata[pcount[7]]!=0)CommandInterpretator(7);else
	__GETW1MN _pcount,14
	RCALL SUBOPT_0x39
	CPI  R30,0
	BREQ _0x166
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x49
	RJMP _0x167
_0x166:
;     862   {
;     863    Tdelay[7]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,14
;     864    istatus[7]=0;
	__PUTB1MN _istatus,7
;     865    pcount[7]=7*16;
	LDI  R30,LOW(112)
	LDI  R31,HIGH(112)
	__PUTW1MN _pcount,14
;     866   } 
_0x167:
;     867  }
;     868  powstate=powsens;
_0x163:
	LDI  R30,0
	SBIC 0x16,1
	LDI  R30,1
	STS  _powstate,R30
;     869 }
	RET
;     870 
;     871 void ScanIN9(void)
;     872 {
_ScanIN9:
;     873 unsigned char i;
;     874        	if((istatus[8]==0)&&w1_init())
	ST   -Y,R16
;	i -> R16
	__GETB1MN _istatus,8
	CPI  R30,0
	BRNE _0x169
	RCALL SUBOPT_0x16
	BRNE _0x16A
_0x169:
	RJMP _0x168
_0x16A:
;     875       	{
;     876       	for (i=0;i<8;i++)idata[i]=0;
	LDI  R16,LOW(0)
_0x16C:
	CPI  R16,8
	BRSH _0x16D
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x17
;     877         w1_search(0xf0,idata);
	SUBI R16,-1
	RJMP _0x16C
_0x16D:
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
;     878         if((w1_dow_crc8(idata,8)==0)&&SearchKey()&&(idata[0]!=0))
	RCALL SUBOPT_0x1A
	BRNE _0x16F
	RCALL SUBOPT_0x1B
	BREQ _0x16F
	RCALL SUBOPT_0x1C
	BRNE _0x170
_0x16F:
	RJMP _0x16E
_0x170:
;     879         {istatus[8]=1;pcount[8]=8*16;Tdelay[8]=0;ipwcnt=10;}
	LDI  R30,LOW(1)
	__PUTB1MN _istatus,8
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	__PUTW1MN _pcount,16
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,16
	LDI  R30,LOW(10)
	STS  _ipwcnt,R30
;     880         }
_0x16E:
;     881 if((istatus[8]==1)&&(Tdelay[8]==0))
_0x168:
	__GETB1MN _istatus,8
	CPI  R30,LOW(0x1)
	BRNE _0x172
	__GETW1MN _Tdelay,16
	SBIW R30,0
	BREQ _0x173
_0x172:
	RJMP _0x171
_0x173:
;     882  {
;     883  pcount[8]++;
	__POINTW2MN _pcount,16
	RCALL SUBOPT_0x48
;     884  if(cdata[pcount[8]]!=0)CommandInterpretator(8);else
	__GETW1MN _pcount,16
	RCALL SUBOPT_0x39
	CPI  R30,0
	BREQ _0x174
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x49
	RJMP _0x175
_0x174:
;     885   {
;     886    Tdelay[8]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,16
;     887    istatus[8]=0;
	__PUTB1MN _istatus,8
;     888    pcount[8]=8*16;
	LDI  R30,LOW(128)
	LDI  R31,HIGH(128)
	__PUTW1MN _pcount,16
;     889   } 
_0x175:
;     890  }
;     891 }
_0x171:
	LD   R16,Y+
	RET
;     892 
;     893 void ScanIN10(void)
;     894 {
_ScanIN10:
;     895 char str[16];
;     896 unsigned char i,a,x;
;     897 
;     898 if((iphone==0)&&(icall==0)&&(sms_counter!=0)&&(sms_proc==0)){SendSMS(GetSMS());sms_proc=6;}
	SBIW R28,16
	RCALL __SAVELOCR3
;	str -> Y+3
;	i -> R16
;	a -> R17
;	x -> R18
	RCALL SUBOPT_0x4A
	BRNE _0x177
	RCALL SUBOPT_0x4B
	BRNE _0x177
	LDS  R26,_sms_counter
	CPI  R26,LOW(0x0)
	BREQ _0x177
	RCALL SUBOPT_0x4C
	BREQ _0x178
_0x177:
	RJMP _0x176
_0x178:
	RCALL _GetSMS
	ST   -Y,R30
	RCALL _SendSMS
	LDI  R30,LOW(6)
	STS  _sms_proc,R30
;     899 
;     900 if((iphone==0)&&(icall==0)&&(sms_proc==0))
_0x176:
	RCALL SUBOPT_0x4A
	BRNE _0x17A
	RCALL SUBOPT_0x4B
	BRNE _0x17A
	RCALL SUBOPT_0x4C
	BREQ _0x17B
_0x17A:
	RJMP _0x179
_0x17B:
;     901 {
;     902 iphone=1;
	LDI  R30,LOW(1)
	MOV  R14,R30
;     903 printf("AT+CLCC");
	__POINTW1FN _0,80
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
;     904 SendCR();
	RCALL _SendCR
;     905 }
;     906 
;     907 if((iphone==2)&&(icall==0))
_0x179:
	LDI  R30,LOW(2)
	CP   R30,R14
	BRNE _0x17D
	RCALL SUBOPT_0x4B
	BREQ _0x17E
_0x17D:
	RJMP _0x17C
_0x17E:
;     908 {
;     909 iphone=3;
	LDI  R30,LOW(3)
	MOV  R14,R30
;     910 for(x=0;x<16;x++)str[x]=0;
	LDI  R18,LOW(0)
_0x180:
	CPI  R18,16
	BRSH _0x181
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x21
;     911 x=0;i=0;
	SUBI R18,-1
	RJMP _0x180
_0x181:
	LDI  R18,LOW(0)
	LDI  R16,LOW(0)
;     912 if(rx_counter)
	TST  R5
	BREQ _0x182
;     913 while(rx_counter)
_0x183:
	TST  R5
	BREQ _0x185
;     914   {
;     915   a=getchar();
	RCALL SUBOPT_0x28
;     916   if((i==1)&&(a!='"')&&(x<16)){str[x]=a;x++;}
	CPI  R16,1
	BRNE _0x187
	CPI  R17,34
	BREQ _0x187
	CPI  R18,16
	BRLO _0x188
_0x187:
	RJMP _0x186
_0x188:
	RCALL SUBOPT_0x4D
	ADD  R26,R30
	ADC  R27,R31
	ST   X,R17
	SUBI R18,-1
;     917   if(a=='"')i++;
_0x186:
	CPI  R17,34
	BRNE _0x189
	SUBI R16,-1
;     918   }
_0x189:
	RJMP _0x183
_0x185:
;     919 if(istatus[9]==0)
_0x182:
	__GETB1MN _istatus,9
	CPI  R30,0
	BREQ PC+2
	RJMP _0x18A
;     920  {  
;     921  a=str[0];
	LDD  R17,Y+3
;     922  if(cdata[17*16+0]!=str[0])a=0;
	__POINTW2MN _cdata,272
	RCALL SUBOPT_0x4E
	BREQ _0x18B
	LDI  R17,LOW(0)
;     923  if(cdata[17*16+1]!=str[1])a=0;
_0x18B:
	__POINTW2MN _cdata,273
	RCALL SUBOPT_0x4F
	BREQ _0x18C
	LDI  R17,LOW(0)
;     924  if(cdata[17*16+2]!=str[2])a=0;
_0x18C:
	__POINTW2MN _cdata,274
	RCALL SUBOPT_0x50
	BREQ _0x18D
	LDI  R17,LOW(0)
;     925  if(cdata[17*16+3]!=str[3])a=0;
_0x18D:
	__POINTW2MN _cdata,275
	RCALL SUBOPT_0x51
	BREQ _0x18E
	LDI  R17,LOW(0)
;     926  if(cdata[17*16+4]!=str[4])a=0;
_0x18E:
	__POINTW2MN _cdata,276
	RCALL SUBOPT_0x52
	BREQ _0x18F
	LDI  R17,LOW(0)
;     927  if(cdata[17*16+5]!=str[5])a=0;
_0x18F:
	__POINTW2MN _cdata,277
	RCALL SUBOPT_0x53
	BREQ _0x190
	LDI  R17,LOW(0)
;     928  if(cdata[17*16+6]!=str[6])a=0;
_0x190:
	__POINTW2MN _cdata,278
	RCALL SUBOPT_0x54
	BREQ _0x191
	LDI  R17,LOW(0)
;     929  if(cdata[17*16+7]!=str[7])a=0;
_0x191:
	__POINTW2MN _cdata,279
	RCALL SUBOPT_0x55
	BREQ _0x192
	LDI  R17,LOW(0)
;     930  if(cdata[17*16+8]!=str[8])a=0;
_0x192:
	__POINTW2MN _cdata,280
	RCALL SUBOPT_0x56
	BREQ _0x193
	LDI  R17,LOW(0)
;     931  if(cdata[17*16+9]!=str[9])a=0;
_0x193:
	__POINTW2MN _cdata,281
	RCALL SUBOPT_0x57
	BREQ _0x194
	LDI  R17,LOW(0)
;     932  if(cdata[17*16+10]!=str[10])a=0;
_0x194:
	__POINTW2MN _cdata,282
	RCALL SUBOPT_0x58
	BREQ _0x195
	LDI  R17,LOW(0)
;     933  if(cdata[17*16+11]!=str[11])a=0;
_0x195:
	__POINTW2MN _cdata,283
	RCALL SUBOPT_0x59
	BREQ _0x196
	LDI  R17,LOW(0)
;     934  if(cdata[17*16+12]!=str[12])a=0;
_0x196:
	__POINTW2MN _cdata,284
	RCALL SUBOPT_0x5A
	BREQ _0x197
	LDI  R17,LOW(0)
;     935  if(cdata[17*16+13]!=str[13])a=0;
_0x197:
	__POINTW2MN _cdata,285
	RCALL SUBOPT_0x5B
	BREQ _0x198
	LDI  R17,LOW(0)
;     936  if(cdata[17*16+14]!=str[14])a=0;
_0x198:
	__POINTW2MN _cdata,286
	RCALL SUBOPT_0x5C
	BREQ _0x199
	LDI  R17,LOW(0)
;     937  if(cdata[17*16+15]!=str[15])a=0;
_0x199:
	__POINTW2MN _cdata,287
	RCALL SUBOPT_0x5D
	BREQ _0x19A
	LDI  R17,LOW(0)
;     938  if(a)
_0x19A:
	CPI  R17,0
	BREQ _0x19B
;     939   {
;     940    Tdelay[9]=0;istatus[9]=1;pcount[9]=9*16;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,18
	LDI  R30,LOW(1)
	__PUTB1MN _istatus,9
	LDI  R30,LOW(144)
	LDI  R31,HIGH(144)
	__PUTW1MN _pcount,18
;     941    printf("ATH");SendCR();
	__POINTW1FN _0,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
	RCALL _SendCR
;     942   }
;     943  }
_0x19B:
;     944  
;     945 if(istatus[10]==0)
_0x18A:
	__GETB1MN _istatus,10
	CPI  R30,0
	BREQ PC+2
	RJMP _0x19C
;     946  {  
;     947  a=str[0];
	LDD  R17,Y+3
;     948  if(cdata[18*16+0]!=str[0])a=0;
	__POINTW2MN _cdata,288
	RCALL SUBOPT_0x4E
	BREQ _0x19D
	LDI  R17,LOW(0)
;     949  if(cdata[18*16+1]!=str[1])a=0;
_0x19D:
	__POINTW2MN _cdata,289
	RCALL SUBOPT_0x4F
	BREQ _0x19E
	LDI  R17,LOW(0)
;     950  if(cdata[18*16+2]!=str[2])a=0;
_0x19E:
	__POINTW2MN _cdata,290
	RCALL SUBOPT_0x50
	BREQ _0x19F
	LDI  R17,LOW(0)
;     951  if(cdata[18*16+3]!=str[3])a=0;
_0x19F:
	__POINTW2MN _cdata,291
	RCALL SUBOPT_0x51
	BREQ _0x1A0
	LDI  R17,LOW(0)
;     952  if(cdata[18*16+4]!=str[4])a=0;
_0x1A0:
	__POINTW2MN _cdata,292
	RCALL SUBOPT_0x52
	BREQ _0x1A1
	LDI  R17,LOW(0)
;     953  if(cdata[18*16+5]!=str[5])a=0;
_0x1A1:
	__POINTW2MN _cdata,293
	RCALL SUBOPT_0x53
	BREQ _0x1A2
	LDI  R17,LOW(0)
;     954  if(cdata[18*16+6]!=str[6])a=0;
_0x1A2:
	__POINTW2MN _cdata,294
	RCALL SUBOPT_0x54
	BREQ _0x1A3
	LDI  R17,LOW(0)
;     955  if(cdata[18*16+7]!=str[7])a=0;
_0x1A3:
	__POINTW2MN _cdata,295
	RCALL SUBOPT_0x55
	BREQ _0x1A4
	LDI  R17,LOW(0)
;     956  if(cdata[18*16+8]!=str[8])a=0;
_0x1A4:
	__POINTW2MN _cdata,296
	RCALL SUBOPT_0x56
	BREQ _0x1A5
	LDI  R17,LOW(0)
;     957  if(cdata[18*16+9]!=str[9])a=0;
_0x1A5:
	__POINTW2MN _cdata,297
	RCALL SUBOPT_0x57
	BREQ _0x1A6
	LDI  R17,LOW(0)
;     958  if(cdata[18*16+10]!=str[10])a=0;
_0x1A6:
	__POINTW2MN _cdata,298
	RCALL SUBOPT_0x58
	BREQ _0x1A7
	LDI  R17,LOW(0)
;     959  if(cdata[18*16+11]!=str[11])a=0;
_0x1A7:
	__POINTW2MN _cdata,299
	RCALL SUBOPT_0x59
	BREQ _0x1A8
	LDI  R17,LOW(0)
;     960  if(cdata[18*16+12]!=str[12])a=0;
_0x1A8:
	__POINTW2MN _cdata,300
	RCALL SUBOPT_0x5A
	BREQ _0x1A9
	LDI  R17,LOW(0)
;     961  if(cdata[18*16+13]!=str[13])a=0;
_0x1A9:
	__POINTW2MN _cdata,301
	RCALL SUBOPT_0x5B
	BREQ _0x1AA
	LDI  R17,LOW(0)
;     962  if(cdata[18*16+14]!=str[14])a=0;
_0x1AA:
	__POINTW2MN _cdata,302
	RCALL SUBOPT_0x5C
	BREQ _0x1AB
	LDI  R17,LOW(0)
;     963  if(cdata[18*16+15]!=str[15])a=0;
_0x1AB:
	__POINTW2MN _cdata,303
	RCALL SUBOPT_0x5D
	BREQ _0x1AC
	LDI  R17,LOW(0)
;     964  if(a)
_0x1AC:
	CPI  R17,0
	BREQ _0x1AD
;     965   {
;     966    Tdelay[10]=0;istatus[10]=1;pcount[10]=10*16;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,20
	LDI  R30,LOW(1)
	__PUTB1MN _istatus,10
	LDI  R30,LOW(160)
	LDI  R31,HIGH(160)
	__PUTW1MN _pcount,20
;     967    printf("ATH");SendCR();
	__POINTW1FN _0,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
	RCALL _SendCR
;     968   }
;     969  }
_0x1AD:
;     970  
;     971 if(istatus[11]==0)
_0x19C:
	__GETB1MN _istatus,11
	CPI  R30,0
	BREQ PC+2
	RJMP _0x1AE
;     972  {  
;     973  a=str[0];
	LDD  R17,Y+3
;     974  if(cdata[19*16+0]!=str[0])a=0;
	__POINTW2MN _cdata,304
	RCALL SUBOPT_0x4E
	BREQ _0x1AF
	LDI  R17,LOW(0)
;     975  if(cdata[19*16+1]!=str[1])a=0;
_0x1AF:
	__POINTW2MN _cdata,305
	RCALL SUBOPT_0x4F
	BREQ _0x1B0
	LDI  R17,LOW(0)
;     976  if(cdata[19*16+2]!=str[2])a=0;
_0x1B0:
	__POINTW2MN _cdata,306
	RCALL SUBOPT_0x50
	BREQ _0x1B1
	LDI  R17,LOW(0)
;     977  if(cdata[19*16+3]!=str[3])a=0;
_0x1B1:
	__POINTW2MN _cdata,307
	RCALL SUBOPT_0x51
	BREQ _0x1B2
	LDI  R17,LOW(0)
;     978  if(cdata[19*16+4]!=str[4])a=0;
_0x1B2:
	__POINTW2MN _cdata,308
	RCALL SUBOPT_0x52
	BREQ _0x1B3
	LDI  R17,LOW(0)
;     979  if(cdata[19*16+5]!=str[5])a=0;
_0x1B3:
	__POINTW2MN _cdata,309
	RCALL SUBOPT_0x53
	BREQ _0x1B4
	LDI  R17,LOW(0)
;     980  if(cdata[19*16+6]!=str[6])a=0;
_0x1B4:
	__POINTW2MN _cdata,310
	RCALL SUBOPT_0x54
	BREQ _0x1B5
	LDI  R17,LOW(0)
;     981  if(cdata[19*16+7]!=str[7])a=0;
_0x1B5:
	__POINTW2MN _cdata,311
	RCALL SUBOPT_0x55
	BREQ _0x1B6
	LDI  R17,LOW(0)
;     982  if(cdata[19*16+8]!=str[8])a=0;
_0x1B6:
	__POINTW2MN _cdata,312
	RCALL SUBOPT_0x56
	BREQ _0x1B7
	LDI  R17,LOW(0)
;     983  if(cdata[19*16+9]!=str[9])a=0;
_0x1B7:
	__POINTW2MN _cdata,313
	RCALL SUBOPT_0x57
	BREQ _0x1B8
	LDI  R17,LOW(0)
;     984  if(cdata[19*16+10]!=str[10])a=0;
_0x1B8:
	__POINTW2MN _cdata,314
	RCALL SUBOPT_0x58
	BREQ _0x1B9
	LDI  R17,LOW(0)
;     985  if(cdata[19*16+11]!=str[11])a=0;
_0x1B9:
	__POINTW2MN _cdata,315
	RCALL SUBOPT_0x59
	BREQ _0x1BA
	LDI  R17,LOW(0)
;     986  if(cdata[19*16+12]!=str[12])a=0;
_0x1BA:
	__POINTW2MN _cdata,316
	RCALL SUBOPT_0x5A
	BREQ _0x1BB
	LDI  R17,LOW(0)
;     987  if(cdata[19*16+13]!=str[13])a=0;
_0x1BB:
	__POINTW2MN _cdata,317
	RCALL SUBOPT_0x5B
	BREQ _0x1BC
	LDI  R17,LOW(0)
;     988  if(cdata[19*16+14]!=str[14])a=0;
_0x1BC:
	__POINTW2MN _cdata,318
	RCALL SUBOPT_0x5C
	BREQ _0x1BD
	LDI  R17,LOW(0)
;     989  if(cdata[19*16+15]!=str[15])a=0;
_0x1BD:
	__POINTW2MN _cdata,319
	RCALL SUBOPT_0x5D
	BREQ _0x1BE
	LDI  R17,LOW(0)
;     990  if(a)
_0x1BE:
	CPI  R17,0
	BREQ _0x1BF
;     991   {
;     992    Tdelay[11]=0;istatus[11]=1;pcount[11]=11*16;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,22
	LDI  R30,LOW(1)
	__PUTB1MN _istatus,11
	LDI  R30,LOW(176)
	LDI  R31,HIGH(176)
	__PUTW1MN _pcount,22
;     993    printf("ATH");SendCR();
	__POINTW1FN _0,71
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x24
	RCALL _SendCR
;     994   }
;     995  }
_0x1BF:
;     996 }
_0x1AE:
;     997         
;     998 if((istatus[9]==1)&&(Tdelay[9]==0))
_0x17C:
	__GETB1MN _istatus,9
	CPI  R30,LOW(0x1)
	BRNE _0x1C1
	__GETW1MN _Tdelay,18
	SBIW R30,0
	BREQ _0x1C2
_0x1C1:
	RJMP _0x1C0
_0x1C2:
;     999  {
;    1000  pcount[9]++;
	__POINTW2MN _pcount,18
	RCALL SUBOPT_0x48
;    1001  if(cdata[pcount[9]]!=0)CommandInterpretator(9);else
	__GETW1MN _pcount,18
	RCALL SUBOPT_0x39
	CPI  R30,0
	BREQ _0x1C3
	LDI  R30,LOW(9)
	RCALL SUBOPT_0x49
	RJMP _0x1C4
_0x1C3:
;    1002   {
;    1003    Tdelay[9]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,18
;    1004    istatus[9]=0;
	__PUTB1MN _istatus,9
;    1005    pcount[9]=9*16;
	LDI  R30,LOW(144)
	LDI  R31,HIGH(144)
	__PUTW1MN _pcount,18
;    1006   } 
_0x1C4:
;    1007  }
;    1008 if((istatus[10]==1)&&(Tdelay[10]==0))
_0x1C0:
	__GETB1MN _istatus,10
	CPI  R30,LOW(0x1)
	BRNE _0x1C6
	__GETW1MN _Tdelay,20
	SBIW R30,0
	BREQ _0x1C7
_0x1C6:
	RJMP _0x1C5
_0x1C7:
;    1009  {
;    1010  pcount[10]++;
	__POINTW2MN _pcount,20
	RCALL SUBOPT_0x48
;    1011  if(cdata[pcount[10]]!=0)CommandInterpretator(10);else
	__GETW1MN _pcount,20
	RCALL SUBOPT_0x39
	CPI  R30,0
	BREQ _0x1C8
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x49
	RJMP _0x1C9
_0x1C8:
;    1012   {
;    1013    Tdelay[10]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,20
;    1014    istatus[10]=0;
	__PUTB1MN _istatus,10
;    1015    pcount[10]=10*16;
	LDI  R30,LOW(160)
	LDI  R31,HIGH(160)
	__PUTW1MN _pcount,20
;    1016   } 
_0x1C9:
;    1017  }
;    1018 if((istatus[11]==1)&&(Tdelay[11]==0))
_0x1C5:
	__GETB1MN _istatus,11
	CPI  R30,LOW(0x1)
	BRNE _0x1CB
	__GETW1MN _Tdelay,22
	SBIW R30,0
	BREQ _0x1CC
_0x1CB:
	RJMP _0x1CA
_0x1CC:
;    1019  {
;    1020  pcount[11]++;
	__POINTW2MN _pcount,22
	RCALL SUBOPT_0x48
;    1021  if(cdata[pcount[11]]!=0)CommandInterpretator(11);else
	__GETW1MN _pcount,22
	RCALL SUBOPT_0x39
	CPI  R30,0
	BREQ _0x1CD
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x49
	RJMP _0x1CE
_0x1CD:
;    1022   {
;    1023    Tdelay[11]=0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__PUTW1MN _Tdelay,22
;    1024    istatus[11]=0;
	__PUTB1MN _istatus,11
;    1025    pcount[11]=11*16;
	LDI  R30,LOW(176)
	LDI  R31,HIGH(176)
	__PUTW1MN _pcount,22
;    1026   } 
_0x1CE:
;    1027  }
;    1028 }
_0x1CA:
	RCALL __LOADLOCR3
	ADIW R28,19
	RET
;    1029 
;    1030 void main(void)
;    1031 {
_main:
;    1032 icall=0;
	RCALL SUBOPT_0x3B
;    1033 init_prog();
	RCALL _init_prog
;    1034 sledpw=1;
	RCALL SUBOPT_0x13
;    1035 InitPhone();
	RCALL _InitPhone
;    1036 InitDev();
	RCALL _InitDev
;    1037 bat=0;
	CBI  0x12,3
;    1038 zub=0;
	CBI  0x12,2
;    1039 zubdr=0;
	CBI  0x11,2
;    1040 batdr=0;
	CBI  0x11,3
;    1041 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x1E
;    1042 
;    1043 while (1)
_0x1CF:
;    1044  {
;    1045   	if(!key)
	SBIC 0x10,5
	RJMP _0x1D2
;    1046 		{
;    1047 		sec=200;
	RCALL SUBOPT_0x15
;    1048 		sledpw=5;
	LDI  R30,LOW(5)
	MOV  R11,R30
;    1049 		while(!key);
_0x1D3:
	SBIS 0x10,5
	RJMP _0x1D3
;    1050 		if(sec<60)Read2Flash();
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R9,R30
	CPC  R10,R31
	BRSH _0x1D6
	RCALL _Read2Flash
;    1051 		if((sec<120)&&(sec>60))ProgKey();
_0x1D6:
	LDI  R30,LOW(120)
	LDI  R31,HIGH(120)
	CP   R9,R30
	CPC  R10,R31
	BRSH _0x1D8
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R30,R9
	CPC  R31,R10
	BRLO _0x1D9
_0x1D8:
	RJMP _0x1D7
_0x1D9:
	RCALL _ProgKey
;    1052 		sledpw=1;
_0x1D7:
	RCALL SUBOPT_0x13
;    1053 		}
;    1054  ScanIN1();
_0x1D2:
	RCALL _ScanIN1
;    1055  ScanIN2();
	RCALL _ScanIN2
;    1056  ScanIN3();
	RCALL _ScanIN3
;    1057  ScanIN4();
	RCALL _ScanIN4
;    1058  ScanIN5();
	RCALL _ScanIN5
;    1059  ScanIN6();
	RCALL _ScanIN6
;    1060  ScanIN78();
	RCALL _ScanIN78
;    1061  ScanIN9();
	RCALL _ScanIN9
;    1062  ScanIN10();		
	RCALL _ScanIN10
;    1063  }
	RJMP _0x1CF
;    1064 }
_0x1DA:
	RJMP _0x1DA

_atoi:
   	ldd  r27,y+1
   	ld   r26,y
__atoi0:
   	ld   r30,x
	ST   -Y,R30
	RCALL _isspace
   	tst  r30
   	breq __atoi1
   	adiw r26,1
   	rjmp __atoi0
__atoi1:
   	clt
   	ld   r30,x
   	cpi  r30,'-'
   	brne __atoi2
   	set
   	rjmp __atoi3
__atoi2:
   	cpi  r30,'+'
   	brne __atoi4
__atoi3:
   	adiw r26,1
__atoi4:
   	clr  r22
   	clr  r23
__atoi5:
   	ld   r30,x
	ST   -Y,R30
	RCALL _isdigit
   	tst  r30
   	breq __atoi6
   	mov  r30,r22
   	mov  r31,r23
   	lsl  r22
   	rol  r23
   	lsl  r22
   	rol  r23
   	add  r22,r30
   	adc  r23,r31
   	lsl  r22
   	rol  r23
   	ld   r30,x+
   	clr  r31
   	subi r30,'0'
   	add  r22,r30
   	adc  r23,r31
   	rjmp __atoi5
__atoi6:
   	mov  r30,r22
   	mov  r31,r23
   	brtc __atoi7
   	com  r30
   	com  r31
   	adiw r30,1
__atoi7:
   	adiw r28,2
   	ret
_ltoa:
	SBIW R28,4
	RCALL __SAVELOCR2
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R17,LOW(0)
	__GETD2S 8
	RCALL __CPD20
	BRGE _0x1DB
	__GETD1S 8
	RCALL __ANEGD1
	__PUTD1S 8
	RCALL SUBOPT_0x5E
	LDI  R30,LOW(45)
	ST   X,R30
_0x1DB:
_0x1DD:
	RCALL SUBOPT_0x5F
	RCALL __DIVD21U
	MOV  R16,R30
	CPI  R16,0
	BRNE _0x1E0
	CPI  R17,0
	BRNE _0x1E0
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x1DF
_0x1E0:
	RCALL SUBOPT_0x5E
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R17,LOW(1)
_0x1DF:
	RCALL SUBOPT_0x5F
	RCALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	__GETD1N 0xA
	RCALL __DIVD21U
	__PUTD1S 2
	RCALL __CPD10
	BRNE _0x1DD
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RCALL SUBOPT_0xE
	RCALL __LOADLOCR2
	ADIW R28,12
	RET
__put_G3:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x41
	BREQ _0x1E2
	LD   R26,Y
	LDD  R27,Y+1
	RCALL SUBOPT_0x48
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x1E3
_0x1E2:
	LDD  R30,Y+2
	RCALL SUBOPT_0x22
_0x1E3:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0x1E4:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	RCALL SUBOPT_0x60
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x1E6
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x1EA
	CPI  R19,37
	BRNE _0x1EB
	LDI  R16,LOW(1)
	RJMP _0x1EC
_0x1EB:
	RCALL SUBOPT_0x61
_0x1EC:
	RJMP _0x1E9
_0x1EA:
	CPI  R30,LOW(0x1)
	BRNE _0x1ED
	CPI  R19,37
	BRNE _0x1EE
	RCALL SUBOPT_0x61
	LDI  R16,LOW(0)
	RJMP _0x1E9
_0x1EE:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x1EF
	LDI  R17,LOW(1)
	RJMP _0x1E9
_0x1EF:
	CPI  R19,43
	BRNE _0x1F0
	LDI  R21,LOW(43)
	RJMP _0x1E9
_0x1F0:
	CPI  R19,32
	BRNE _0x1F1
	LDI  R21,LOW(32)
	RJMP _0x1E9
_0x1F1:
	RJMP _0x1F2
_0x1ED:
	CPI  R30,LOW(0x2)
	BRNE _0x1F3
_0x1F2:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x1F4
	ORI  R17,LOW(128)
	RJMP _0x1E9
_0x1F4:
	RJMP _0x1F5
_0x1F3:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x1E9
_0x1F5:
	CPI  R19,48
	BRLO _0x1F8
	CPI  R19,58
	BRLO _0x1F9
_0x1F8:
	RJMP _0x1F7
_0x1F9:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x1E9
_0x1F7:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x1FD
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x63
	RJMP _0x1FE
_0x1FD:
	CPI  R30,LOW(0x73)
	BRNE _0x200
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x64
	RCALL _strlen
	MOV  R16,R30
	RJMP _0x201
_0x200:
	CPI  R30,LOW(0x70)
	BRNE _0x203
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x64
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x201:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0x204
_0x203:
	CPI  R30,LOW(0x64)
	BREQ _0x207
	CPI  R30,LOW(0x69)
	BRNE _0x208
_0x207:
	ORI  R17,LOW(4)
	RJMP _0x209
_0x208:
	CPI  R30,LOW(0x75)
	BRNE _0x20A
_0x209:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0x20B
_0x20A:
	CPI  R30,LOW(0x58)
	BRNE _0x20D
	ORI  R17,LOW(8)
	RJMP _0x20E
_0x20D:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x23C
_0x20E:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0x20B:
	SBRS R17,2
	RJMP _0x210
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x65
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x211
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0x211:
	CPI  R21,0
	BREQ _0x212
	SUBI R16,-LOW(1)
	RJMP _0x213
_0x212:
	ANDI R17,LOW(251)
_0x213:
	RJMP _0x214
_0x210:
	RCALL SUBOPT_0x62
	RCALL SUBOPT_0x65
_0x214:
_0x204:
	SBRC R17,0
	RJMP _0x215
_0x216:
	CP   R16,R20
	BRSH _0x218
	SBRS R17,7
	RJMP _0x219
	SBRS R17,2
	RJMP _0x21A
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x21B
_0x21A:
	LDI  R19,LOW(48)
_0x21B:
	RJMP _0x21C
_0x219:
	LDI  R19,LOW(32)
_0x21C:
	RCALL SUBOPT_0x61
	SUBI R20,LOW(1)
	RJMP _0x216
_0x218:
_0x215:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x21D
_0x21E:
	CPI  R18,0
	BREQ _0x220
	SBRS R17,3
	RJMP _0x221
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RCALL SUBOPT_0x60
	RJMP _0x244
_0x221:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x244:
	ST   -Y,R30
	RCALL SUBOPT_0x66
	CPI  R20,0
	BREQ _0x223
	SUBI R20,LOW(1)
_0x223:
	SUBI R18,LOW(1)
	RJMP _0x21E
_0x220:
	RJMP _0x224
_0x21D:
_0x226:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x228
	SBRS R17,3
	RJMP _0x229
	SUBI R19,-LOW(7)
	RJMP _0x22A
_0x229:
	SUBI R19,-LOW(39)
_0x22A:
_0x228:
	SBRC R17,4
	RJMP _0x22C
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x22E
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x22D
_0x22E:
	ORI  R17,LOW(16)
	RJMP _0x230
_0x22D:
	CP   R20,R18
	BRLO _0x232
	SBRS R17,0
	RJMP _0x233
_0x232:
	RJMP _0x231
_0x233:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x234
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x230:
	SBRS R17,2
	RJMP _0x235
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x66
	CPI  R20,0
	BREQ _0x236
	SUBI R20,LOW(1)
_0x236:
_0x235:
_0x234:
_0x22C:
	RCALL SUBOPT_0x61
	CPI  R20,0
	BREQ _0x237
	SUBI R20,LOW(1)
_0x237:
_0x231:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x227
	RJMP _0x226
_0x227:
_0x224:
	SBRS R17,0
	RJMP _0x238
_0x239:
	CPI  R20,0
	BREQ _0x23B
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x63
	RJMP _0x239
_0x23B:
_0x238:
_0x23C:
_0x1FE:
	LDI  R16,LOW(0)
_0x1E9:
	RJMP _0x1E4
_0x1E6:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	__PUTW2R 16,17
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	MOV  R30,R16
	LD   R16,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R31,0
	SUBI R30,LOW(-_tx_buffer)
	SBCI R31,HIGH(-_tx_buffer)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	LD   R26,Y
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R31,0
	SUBI R30,LOW(-_sms_buffer)
	SBCI R31,HIGH(-_sms_buffer)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(0)
	STS  _sms_wr_index,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(0)
	STS  _sms_counter,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(0)
	STS  _sms_rd_index,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(253)
	OUT  0x2D,R30
	LDI  R30,LOW(48)
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	MOV  R30,R16
	LDI  R26,LOW(_Tdelay)
	LDI  R27,HIGH(_Tdelay)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	SBIW R30,1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	RCALL __GTB12U
	BST  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	IN   R26,0x12
	BLD  R26,4
	OUT  0x12,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES
SUBOPT_0xC:
	__GETW1R 16,17
	LDI  R26,LOW(_pcount)
	LDI  R27,HIGH(_pcount)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	__GETW1R 16,17
	RCALL __LSLW4
	ST   X+,R30
	ST   X,R31
	__GETW1R 16,17
	LDI  R26,LOW(_Tdelay)
	LDI  R27,HIGH(_Tdelay)
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 55 TIMES
SUBOPT_0xD:
	LDI  R26,LOW(_istatus)
	LDI  R27,HIGH(_istatus)
	ADD  R26,R16
	ADC  R27,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	ADIW R26,4
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x10:
	LDI  R30,LOW(_idata)
	LDI  R31,HIGH(_idata)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDI  R31,0
	SUBI R30,LOW(-_ibase)
	SBCI R31,HIGH(-_ibase)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDI  R30,LOW(1)
	MOV  R12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x13:
	LDI  R30,LOW(1)
	MOV  R11,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x14:
	MOV  R26,R16
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	__PUTW1R 9,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	RCALL _w1_init
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	SUBI R26,LOW(-_idata)
	SBCI R27,HIGH(-_idata)
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(240)
	ST   -Y,R30
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	RCALL _w1_search
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL _w1_dow_crc8
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	RCALL _SearchKey
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LDS  R26,_idata
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1D:
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x1E:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1F:
	MOV  R30,R16
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	MOV  R26,R30
	LDI  R30,LOW(57)
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	ADD  R26,R30
	ADC  R27,R31
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x22:
	ST   -Y,R30
	RJMP _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x23:
	RCALL _printf
	ADIW R28,2
	RCALL _SendCR
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x24:
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _ltoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x26:
	MOVW R26,R28
	ADIW R26,6
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x27:
	RCALL _SendCR
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x28:
	RCALL _getchar
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x29:
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SUBI R26,LOW(-_cdata)
	SBCI R27,HIGH(-_cdata)
	MOV  R30,R17
	RCALL __EEPROMWRB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2A:
	ST   -Y,R16
	LDD  R26,Y+1
	CPI  R26,LOW(0x7)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2B:
	LDD  R30,Y+1
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	LDD  R30,Y+1
	SUBI R30,LOW(1)
	STD  Y+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2D:
	SWAP R30
	ANDI R30,0xF0
	LDI  R31,0
	SUBI R30,LOW(-_cdata)
	SBCI R31,HIGH(-_cdata)
	MOVW R26,R30
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2E:
	LDI  R26,LOW(_Tdelay)
	LDI  R27,HIGH(_Tdelay)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	LDD  R26,Y+1
	LDI  R27,0
	SUBI R26,LOW(-_istatus)
	SBCI R27,HIGH(-_istatus)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x30:
	LDI  R30,LOW(2)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	LDD  R30,Y+1
	LDI  R26,LOW(_pcount)
	LDI  R27,HIGH(_pcount)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	LDD  R30,Y+1
	SWAP R30
	ANDI R30,0xF0
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	MOV  R30,R16
	RJMP SUBOPT_0x2D

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	MOV  R30,R16
	RJMP SUBOPT_0x2E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x34:
	MOV  R30,R16
	LDI  R26,LOW(_pcount)
	LDI  R27,HIGH(_pcount)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	MOV  R30,R16
	SWAP R30
	ANDI R30,0xF0
	LDI  R31,0
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x35:
	LDD  R30,Y+2
	LDI  R26,LOW(_pcount)
	LDI  R27,HIGH(_pcount)
	LDI  R31,0
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x36:
	__GETW1R 16,17
	ADIW R30,1
	SUBI R30,LOW(-_cdata)
	SBCI R31,HIGH(-_cdata)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _GetDigit

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x37:
	LDD  R30,Y+2
	LDI  R26,LOW(_Tdelay)
	LDI  R27,HIGH(_Tdelay)
	LDI  R31,0
	LSL  R30
	ROL  R31
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES
SUBOPT_0x38:
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 40 TIMES
SUBOPT_0x39:
	SUBI R30,LOW(-_cdata)
	SBCI R31,HIGH(-_cdata)
	MOVW R26,R30
	RCALL __EEPROMRDB
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x3A:
	__GETW1R 16,17
	ADIW R30,2
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3B:
	LDI  R30,LOW(0)
	STS  _icall,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES
SUBOPT_0x3C:
	__GETW1R 16,17
	RCALL __LSLW4
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x3D:
	LD   R26,X
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x3E:
	LDI  R30,LOW(1)
	ST   X,R30
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x3F:
	LD   R26,X
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 18 TIMES
SUBOPT_0x40:
	__GETW1R 16,17
	LDI  R26,LOW(_Tdelay)
	LDI  R27,HIGH(_Tdelay)
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x41:
	RCALL __GETW1P
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES
SUBOPT_0x42:
	__GETW1R 16,17
	LDI  R26,LOW(_pcount)
	LDI  R27,HIGH(_pcount)
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x43:
	RCALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RJMP SUBOPT_0x42

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x44:
	RCALL __GETW1P
	RJMP SUBOPT_0x39

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x45:
	ST   -Y,R16
	RJMP _CommandInterpretator

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x46:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES
SUBOPT_0x47:
	__GETW1R 16,17
	RCALL __LSLW4
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x48:
	RCALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x49:
	ST   -Y,R30
	RJMP _CommandInterpretator

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4A:
	LDI  R30,LOW(0)
	CP   R30,R14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4B:
	LDS  R26,_icall
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4C:
	LDS  R26,_sms_proc
	CPI  R26,LOW(0x0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4D:
	MOV  R30,R18
	LDI  R31,0
	MOVW R26,R28
	ADIW R26,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4E:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+3
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x4F:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+4
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x50:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+5
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x51:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+6
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x52:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+7
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x53:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+8
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x54:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+9
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x55:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+10
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x56:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+11
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x57:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+12
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x58:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+13
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x59:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+14
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5A:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+15
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5B:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+16
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5C:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+17
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5D:
	RCALL __EEPROMRDB
	MOV  R26,R30
	LDD  R30,Y+18
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5E:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5F:
	__GETD1S 2
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x60:
	SBIW R30,1
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x61:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x62:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x63:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x64:
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x65:
	ADIW R26,4
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x66:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

_isdigit:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,'0'
	brlo __isdigit0
	cpi  r31,'9'+1
	brlo __isdigit1
__isdigit0:
	clr  r30
__isdigit1:
	ret

_isspace:
	ldi  r30,1
	ld   r31,y+
	cpi  r31,' '
	breq __isspace1
	cpi  r31,9
	brlo __isspace0
	cpi  r31,14
	brlo __isspace1
__isspace0:
	clr  r30
__isspace1:
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x733
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x375
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x22
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USB 0xBB
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x2CF
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x5
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x1B
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USB 0xC5
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x5
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x20
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USB 0xB8
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0xC
	set
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	ldd  r27,y+1
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+2
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,3
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__GTB12:
	CP   R30,R26
	LDI  R30,1
	BRLT __GTB12T
	CLR  R30
__GTB12T:
	RET

__GTB12U:
	CP   R30,R26
	LDI  R30,1
	BRLO __GTB12U1
	CLR  R30
__GTB12U1:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIC EECR,EEWE
	RJMP __EEPROMWRB
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__LSLB3:
	LSL  R30
	LSL  R30
	LSL  R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
